blob: 50cd4df313ec443cb7867c31982b8afdc26c81db [file] [log] [blame]
Scott Anderson1a5fc952012-03-07 17:15:06 -08001function hmm() {
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07002cat <<EOF
Jeff Gastonc6dfc4e2017-05-30 17:12:37 -07003
4Run "m help" for help with the build system itself.
5
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08006Invoke ". build/envsetup.sh" from your shell to add the following functions to your environment:
Steven Moreland62054a42018-12-06 10:11:40 -08007- lunch: lunch <product_name>-<build_variant>
8 Selects <product_name> as the product to build, and <build_variant> as the variant to
9 build, and stores those selections in the environment to be read by subsequent
10 invocations of 'm' etc.
Elliott Hughesf71c05a2020-03-06 16:46:59 -080011- tapas: tapas [<App1> <App2> ...] [arm|x86|arm64|x86_64] [eng|userdebug|user]
Martin Stjernholmf692c752021-04-12 00:01:10 +010012 Sets up the build environment for building unbundled apps (APKs).
13- banchan: banchan <module1> [<module2> ...] [arm|x86|arm64|x86_64] [eng|userdebug|user]
14 Sets up the build environment for building unbundled modules (APEXes).
Anton Hanssonece9c482019-02-04 18:15:39 +000015- croot: Changes directory to the top of the tree, or a subdirectory thereof.
Steven Moreland62054a42018-12-06 10:11:40 -080016- m: Makes from the top of the tree.
Dan Willemsen67074fe2019-10-30 12:35:34 -070017- mm: Builds and installs all of the modules in the current directory, and their
18 dependencies.
19- mmm: Builds and installs all of the modules in the supplied directories, and their
20 dependencies.
Steven Moreland62054a42018-12-06 10:11:40 -080021 To limit the modules being built use the syntax: mmm dir/:target1,target2.
Dan Willemsen67074fe2019-10-30 12:35:34 -070022- mma: Same as 'mm'
23- mmma: Same as 'mmm'
Steven Moreland62054a42018-12-06 10:11:40 -080024- provision: Flash device with all required partitions. Options will be passed on to fastboot.
25- cgrep: Greps on all local C/C++ files.
26- ggrep: Greps on all local Gradle files.
Orion Hodson831472d2019-10-25 11:35:15 +010027- gogrep: Greps on all local Go files.
Steven Moreland62054a42018-12-06 10:11:40 -080028- jgrep: Greps on all local Java files.
Taesu Leeea0cecd2020-10-28 11:05:18 +090029- ktgrep: Greps on all local Kotlin files.
Steven Moreland62054a42018-12-06 10:11:40 -080030- resgrep: Greps on all local res/*.xml files.
31- mangrep: Greps on all local AndroidManifest.xml files.
Jaewoong Jung892d0fe2019-05-04 10:06:28 -070032- mgrep: Greps on all local Makefiles and *.bp files.
Jeff Sharkeyf17cddf2019-08-21 12:51:26 -060033- owngrep: Greps on all local OWNERS files.
Alistair Delva176e5342021-02-22 13:31:26 -080034- rsgrep: Greps on all local Rust files.
Steven Moreland62054a42018-12-06 10:11:40 -080035- sepgrep: Greps on all local sepolicy files.
36- sgrep: Greps on all local source files.
37- godir: Go to the directory containing a file.
38- allmod: List all modules.
39- gomod: Go to the directory containing a module.
Rett Berg78d1c932019-01-24 14:34:23 -080040- pathmod: Get the directory containing a module.
Cole Faust24c36db2021-01-23 02:39:37 +000041- outmod: Gets the location of a module's installed outputs with a certain extension.
Joe Onorato2c1aa472021-02-25 16:42:39 -080042- dirmods: Gets the modules defined in a given directory.
Cole Faust24c36db2021-01-23 02:39:37 +000043- installmod: Adb installs a module's built APK.
44- refreshmod: Refresh list of modules for allmod/gomod/pathmod/outmod/installmod.
Steven Moreland74114f12020-09-10 01:23:32 +000045- syswrite: Remount partitions (e.g. system.img) as writable, rebooting if necessary.
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -070046
Roland Levillain39341922015-10-20 12:48:19 +010047Environment options:
Steven Moreland115d1f52019-09-26 16:30:28 -070048- SANITIZE_HOST: Set to 'address' to use ASAN for all host modules.
Sasha Smundak9f27cc02019-01-31 13:25:31 -080049- ANDROID_QUIET_BUILD: set to 'true' to display only the essential messages.
Dan Albert4ae5d4b2014-10-31 16:23:08 -070050
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -070051Look at the source to view more functions. The complete list is:
52EOF
Christopher Ferris55257d22017-03-23 11:08:58 -070053 local T=$(gettop)
54 local A=""
55 local i
Jacky Cao89483b82015-05-15 22:12:53 +080056 for i in `cat $T/build/envsetup.sh | sed -n "/^[[:blank:]]*function /s/function \([a-z_]*\).*/\1/p" | sort | uniq`; do
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -070057 A="$A $i"
58 done
59 echo $A
60}
61
Ying Wang08800fd2016-03-03 20:57:21 -080062# Get all the build variables needed by this script in a single call to the build system.
Matt Alexanderd9c56562020-05-21 10:49:17 +000063function build_build_var_cache()
64{
Christopher Ferris55257d22017-03-23 11:08:58 -070065 local T=$(gettop)
Ying Wang08800fd2016-03-03 20:57:21 -080066 # Grep out the variable names from the script.
Jim Tanga881a252018-06-19 16:34:41 +080067 cached_vars=(`cat $T/build/envsetup.sh | tr '()' ' ' | awk '{for(i=1;i<=NF;i++) if($i~/get_build_var/) print $(i+1)}' | sort -u | tr '\n' ' '`)
68 cached_abs_vars=(`cat $T/build/envsetup.sh | tr '()' ' ' | awk '{for(i=1;i<=NF;i++) if($i~/get_abs_build_var/) print $(i+1)}' | sort -u | tr '\n' ' '`)
Ying Wang08800fd2016-03-03 20:57:21 -080069 # Call the build system to dump the "<val>=<value>" pairs as a shell script.
Steven Moreland05402962018-01-05 12:13:11 -080070 build_dicts_script=`\builtin cd $T; build/soong/soong_ui.bash --dumpvars-mode \
Jim Tanga881a252018-06-19 16:34:41 +080071 --vars="${cached_vars[*]}" \
72 --abs-vars="${cached_abs_vars[*]}" \
Dan Willemsenaf88c412017-07-14 11:29:44 -070073 --var-prefix=var_cache_ \
74 --abs-var-prefix=abs_var_cache_`
Ying Wang08800fd2016-03-03 20:57:21 -080075 local ret=$?
Matt Alexanderd9c56562020-05-21 10:49:17 +000076 if [ $ret -ne 0 ]
77 then
Ying Wang08800fd2016-03-03 20:57:21 -080078 unset build_dicts_script
79 return $ret
80 fi
Dan Willemsenaf88c412017-07-14 11:29:44 -070081 # Execute the script to store the "<val>=<value>" pairs as shell variables.
Ying Wang08800fd2016-03-03 20:57:21 -080082 eval "$build_dicts_script"
Ying Wang08800fd2016-03-03 20:57:21 -080083 ret=$?
Ying Wangf0cb3972016-03-04 13:56:23 -080084 unset build_dicts_script
Matt Alexanderd9c56562020-05-21 10:49:17 +000085 if [ $ret -ne 0 ]
86 then
Ying Wang08800fd2016-03-03 20:57:21 -080087 return $ret
88 fi
89 BUILD_VAR_CACHE_READY="true"
90}
91
Ying Wangf0cb3972016-03-04 13:56:23 -080092# Delete the build var cache, so that we can still call into the build system
Ying Wang08800fd2016-03-03 20:57:21 -080093# to get build variables not listed in this script.
Matt Alexanderd9c56562020-05-21 10:49:17 +000094function destroy_build_var_cache()
95{
Ying Wang08800fd2016-03-03 20:57:21 -080096 unset BUILD_VAR_CACHE_READY
Christopher Ferris55257d22017-03-23 11:08:58 -070097 local v
Ying Wang08800fd2016-03-03 20:57:21 -080098 for v in $cached_vars; do
99 unset var_cache_$v
100 done
101 unset cached_vars
102 for v in $cached_abs_vars; do
103 unset abs_var_cache_$v
104 done
105 unset cached_abs_vars
106}
107
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700108# Get the value of a build variable as an absolute path.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000109function get_abs_build_var()
110{
111 if [ "$BUILD_VAR_CACHE_READY" = "true" ]
112 then
Vishwath Mohan7d35f002016-03-11 10:00:40 -0800113 eval "echo \"\${abs_var_cache_$1}\""
Timi0469c3f2021-04-15 16:41:18 +0200114 return
Ying Wang08800fd2016-03-03 20:57:21 -0800115 fi
116
Christopher Ferris55257d22017-03-23 11:08:58 -0700117 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700118 if [ ! "$T" ]; then
119 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
120 return
121 fi
Dan Willemsenaf88c412017-07-14 11:29:44 -0700122 (\cd $T; build/soong/soong_ui.bash --dumpvar-mode --abs $1)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700123}
124
125# Get the exact value of a build variable.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000126function get_build_var()
127{
128 if [ "$BUILD_VAR_CACHE_READY" = "true" ]
129 then
Vishwath Mohan7d35f002016-03-11 10:00:40 -0800130 eval "echo \"\${var_cache_$1}\""
Roland Levillain23c46cf2020-03-31 16:11:05 +0100131 return 0
Ying Wang08800fd2016-03-03 20:57:21 -0800132 fi
133
Christopher Ferris55257d22017-03-23 11:08:58 -0700134 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700135 if [ ! "$T" ]; then
136 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
Roland Levillain23c46cf2020-03-31 16:11:05 +0100137 return 1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700138 fi
Dan Willemsenaf88c412017-07-14 11:29:44 -0700139 (\cd $T; build/soong/soong_ui.bash --dumpvar-mode $1)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800140}
141
142# check to see if the supplied product is one we can build
Matt Alexanderd9c56562020-05-21 10:49:17 +0000143function check_product()
144{
Christopher Ferris55257d22017-03-23 11:08:58 -0700145 local T=$(gettop)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800146 if [ ! "$T" ]; then
147 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
148 return
149 fi
Jeff Browne33ba4c2011-07-11 22:11:46 -0700150 TARGET_PRODUCT=$1 \
151 TARGET_BUILD_VARIANT= \
152 TARGET_BUILD_TYPE= \
Joe Onoratoda12daf2010-06-09 18:18:31 -0700153 TARGET_BUILD_APPS= \
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800154 get_build_var TARGET_DEVICE > /dev/null
155 # hide successful answers, but allow the errors to show
156}
157
158VARIANT_CHOICES=(user userdebug eng)
159
160# check to see if the supplied variant is valid
Matt Alexanderd9c56562020-05-21 10:49:17 +0000161function check_variant()
162{
Christopher Ferris55257d22017-03-23 11:08:58 -0700163 local v
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800164 for v in ${VARIANT_CHOICES[@]}
165 do
Matt Alexanderd9c56562020-05-21 10:49:17 +0000166 if [ "$v" = "$1" ]
167 then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800168 return 0
169 fi
170 done
171 return 1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700172}
173
Matt Alexanderd9c56562020-05-21 10:49:17 +0000174function setpaths()
175{
Christopher Ferris55257d22017-03-23 11:08:58 -0700176 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700177 if [ ! "$T" ]; then
178 echo "Couldn't locate the top of the tree. Try setting TOP."
179 return
180 fi
181
182 ##################################################################
183 # #
184 # Read me before you modify this code #
185 # #
186 # This function sets ANDROID_BUILD_PATHS to what it is adding #
187 # to PATH, and the next time it is run, it removes that from #
188 # PATH. This is required so lunch can be run more than once #
189 # and still have working paths. #
190 # #
191 ##################################################################
192
Raphael Mollc639c782011-06-20 17:25:01 -0700193 # Note: on windows/cygwin, ANDROID_BUILD_PATHS will contain spaces
194 # due to "C:\Program Files" being in the path.
195
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700196 # out with the old
Matt Alexanderd9c56562020-05-21 10:49:17 +0000197 if [ -n "$ANDROID_BUILD_PATHS" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700198 export PATH=${PATH/$ANDROID_BUILD_PATHS/}
199 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +0000200 if [ -n "$ANDROID_PRE_BUILD_PATHS" ] ; then
Doug Zongker29034982011-04-22 08:16:56 -0700201 export PATH=${PATH/$ANDROID_PRE_BUILD_PATHS/}
Ying Wangaa1c9b52012-11-26 20:51:59 -0800202 # strip leading ':', if any
203 export PATH=${PATH/:%/}
Jeff Hamilton4a1c70e2010-06-21 18:26:38 -0500204 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700205
206 # and in with the new
Christopher Ferris55257d22017-03-23 11:08:58 -0700207 local prebuiltdir=$(getprebuilt)
208 local gccprebuiltdir=$(get_abs_build_var ANDROID_GCC_PREBUILTS)
Raphael732936d2011-06-22 14:35:32 -0700209
Ben Cheng8bc4c432012-11-16 13:29:13 -0800210 # defined in core/config.mk
Christopher Ferris55257d22017-03-23 11:08:58 -0700211 local targetgccversion=$(get_build_var TARGET_GCC_VERSION)
212 local targetgccversion2=$(get_build_var 2ND_TARGET_GCC_VERSION)
Ben Cheng15266702012-12-10 16:04:39 -0800213 export TARGET_GCC_VERSION=$targetgccversion
Ben Cheng8bc4c432012-11-16 13:29:13 -0800214
Raphael Mollc639c782011-06-20 17:25:01 -0700215 # The gcc toolchain does not exists for windows/cygwin. In this case, do not reference it.
Ben Chengfba67bf2014-02-25 10:27:07 -0800216 export ANDROID_TOOLCHAIN=
217 export ANDROID_TOOLCHAIN_2ND_ARCH=
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200218 local ARCH=$(get_build_var TARGET_ARCH)
Christopher Ferris55257d22017-03-23 11:08:58 -0700219 local toolchaindir toolchaindir2=
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200220 case $ARCH in
Matt Alexanderd9c56562020-05-21 10:49:17 +0000221 x86) toolchaindir=x86/x86_64-linux-android-$targetgccversion/bin
Mark D Horn7d0ede72012-03-14 14:20:30 -0700222 ;;
Matt Alexanderd9c56562020-05-21 10:49:17 +0000223 x86_64) toolchaindir=x86/x86_64-linux-android-$targetgccversion/bin
Pavel Chupinfd82a492012-11-26 09:50:07 +0400224 ;;
Matt Alexanderd9c56562020-05-21 10:49:17 +0000225 arm) toolchaindir=arm/arm-linux-androideabi-$targetgccversion/bin
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200226 ;;
Matt Alexanderd9c56562020-05-21 10:49:17 +0000227 arm64) toolchaindir=aarch64/aarch64-linux-android-$targetgccversion/bin;
228 toolchaindir2=arm/arm-linux-androideabi-$targetgccversion2/bin
Ben Chengdb4fc202013-10-04 16:02:59 -0700229 ;;
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200230 *)
231 echo "Can't find toolchain for unknown architecture: $ARCH"
232 toolchaindir=xxxxxxxxx
Mark D Horn7d0ede72012-03-14 14:20:30 -0700233 ;;
234 esac
Jing Yuf5172c72012-03-29 20:45:50 -0700235 if [ -d "$gccprebuiltdir/$toolchaindir" ]; then
Ben Chengfba67bf2014-02-25 10:27:07 -0800236 export ANDROID_TOOLCHAIN=$gccprebuiltdir/$toolchaindir
Raphael Mollc639c782011-06-20 17:25:01 -0700237 fi
Raphael732936d2011-06-22 14:35:32 -0700238
Christopher Ferris55257d22017-03-23 11:08:58 -0700239 if [ "$toolchaindir2" -a -d "$gccprebuiltdir/$toolchaindir2" ]; then
Ben Chengfba67bf2014-02-25 10:27:07 -0800240 export ANDROID_TOOLCHAIN_2ND_ARCH=$gccprebuiltdir/$toolchaindir2
241 fi
242
Dan Willemsen838dcec2021-09-30 22:40:34 +0000243 export ANDROID_DEV_SCRIPTS=$T/development/scripts:$T/prebuilts/devtools/tools
Yueyao Zhuefc786a2017-04-07 14:11:54 -0700244
245 # add kernel specific binaries
246 case $(uname -s) in
247 Linux)
248 export ANDROID_DEV_SCRIPTS=$ANDROID_DEV_SCRIPTS:$T/prebuilts/misc/linux-x86/dtc:$T/prebuilts/misc/linux-x86/libufdt
249 ;;
250 *)
251 ;;
252 esac
253
Torne (Richard Coles)0091bae2017-10-03 16:31:18 -0400254 ANDROID_BUILD_PATHS=$(get_build_var ANDROID_BUILD_PATHS):$ANDROID_TOOLCHAIN
Martin Stjernholm6a012262021-11-24 14:56:15 +0000255 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_TOOLCHAIN_2ND_ARCH
Yi Kongdfd00b12019-05-21 16:00:04 -0700256 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_DEV_SCRIPTS
257
258 # Append llvm binutils prebuilts path to ANDROID_BUILD_PATHS.
259 local ANDROID_LLVM_BINUTILS=$(get_abs_build_var ANDROID_CLANG_PREBUILTS)/llvm-binutils-stable
260 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_LLVM_BINUTILS
David 'Digit' Turner94d16e52014-05-05 16:13:50 +0200261
Stephen Hinesaa8d72c2020-02-04 09:15:18 -0800262 # Set up ASAN_SYMBOLIZER_PATH for SANITIZE_HOST=address builds.
263 export ASAN_SYMBOLIZER_PATH=$ANDROID_LLVM_BINUTILS/llvm-symbolizer
264
David 'Digit' Turner94d16e52014-05-05 16:13:50 +0200265 # If prebuilts/android-emulator/<system>/ exists, prepend it to our PATH
266 # to ensure that the corresponding 'emulator' binaries are used.
267 case $(uname -s) in
268 Darwin)
269 ANDROID_EMULATOR_PREBUILTS=$T/prebuilts/android-emulator/darwin-x86_64
270 ;;
271 Linux)
272 ANDROID_EMULATOR_PREBUILTS=$T/prebuilts/android-emulator/linux-x86_64
273 ;;
274 *)
275 ANDROID_EMULATOR_PREBUILTS=
276 ;;
277 esac
278 if [ -n "$ANDROID_EMULATOR_PREBUILTS" -a -d "$ANDROID_EMULATOR_PREBUILTS" ]; then
Yi Kongdfd00b12019-05-21 16:00:04 -0700279 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_EMULATOR_PREBUILTS
David 'Digit' Turner94d16e52014-05-05 16:13:50 +0200280 export ANDROID_EMULATOR_PREBUILTS
281 fi
282
Jim Tangb3fda302018-12-22 10:24:55 +0800283 # Append asuite prebuilts path to ANDROID_BUILD_PATHS.
284 local os_arch=$(get_build_var HOST_PREBUILT_TAG)
Ryan Prichard8426a192019-07-15 18:05:29 -0700285 local ACLOUD_PATH="$T/prebuilts/asuite/acloud/$os_arch"
286 local AIDEGEN_PATH="$T/prebuilts/asuite/aidegen/$os_arch"
287 local ATEST_PATH="$T/prebuilts/asuite/atest/$os_arch"
Martin Stjernholm6a012262021-11-24 14:56:15 +0000288 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ACLOUD_PATH:$AIDEGEN_PATH:$ATEST_PATH
Jim Tangb3fda302018-12-22 10:24:55 +0800289
Martin Stjernholm6a012262021-11-24 14:56:15 +0000290 export ANDROID_BUILD_PATHS=$(tr -s : <<<"${ANDROID_BUILD_PATHS}:")
Ryan Prichard8426a192019-07-15 18:05:29 -0700291 export PATH=$ANDROID_BUILD_PATHS$PATH
Jim Tang22f4c322018-12-17 15:21:53 +0800292
293 # out with the duplicate old
294 if [ -n $ANDROID_PYTHONPATH ]; then
295 export PYTHONPATH=${PYTHONPATH//$ANDROID_PYTHONPATH/}
296 fi
297 # and in with the new
298 export ANDROID_PYTHONPATH=$T/development/python-packages:
Jim Tangc4dba1d2019-07-25 16:54:27 +0800299 if [ -n $VENDOR_PYTHONPATH ]; then
300 ANDROID_PYTHONPATH=$ANDROID_PYTHONPATH$VENDOR_PYTHONPATH
301 fi
Jim Tang22f4c322018-12-17 15:21:53 +0800302 export PYTHONPATH=$ANDROID_PYTHONPATH$PYTHONPATH
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800303
Colin Crosse97e6932017-06-30 16:01:45 -0700304 export ANDROID_JAVA_HOME=$(get_abs_build_var ANDROID_JAVA_HOME)
305 export JAVA_HOME=$ANDROID_JAVA_HOME
306 export ANDROID_JAVA_TOOLCHAIN=$(get_abs_build_var ANDROID_JAVA_TOOLCHAIN)
307 export ANDROID_PRE_BUILD_PATHS=$ANDROID_JAVA_TOOLCHAIN:
308 export PATH=$ANDROID_PRE_BUILD_PATHS$PATH
Jeff Hamilton4a1c70e2010-06-21 18:26:38 -0500309
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800310 unset ANDROID_PRODUCT_OUT
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700311 export ANDROID_PRODUCT_OUT=$(get_abs_build_var PRODUCT_OUT)
312 export OUT=$ANDROID_PRODUCT_OUT
313
Jeff Brown8fd5cce2011-03-24 17:03:06 -0700314 unset ANDROID_HOST_OUT
315 export ANDROID_HOST_OUT=$(get_abs_build_var HOST_OUT)
316
Jiyong Parkc02b1c42020-11-03 11:06:39 +0900317 unset ANDROID_SOONG_HOST_OUT
318 export ANDROID_SOONG_HOST_OUT=$(get_abs_build_var SOONG_HOST_OUT)
319
Simran Basidd050ed2017-02-13 13:46:48 -0800320 unset ANDROID_HOST_OUT_TESTCASES
321 export ANDROID_HOST_OUT_TESTCASES=$(get_abs_build_var HOST_OUT_TESTCASES)
322
323 unset ANDROID_TARGET_OUT_TESTCASES
324 export ANDROID_TARGET_OUT_TESTCASES=$(get_abs_build_var TARGET_OUT_TESTCASES)
325
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800326 # needed for building linux on MacOS
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700327 # TODO: fix the path
328 #export HOST_EXTRACFLAGS="-I "$T/system/kernel_headers/host_include
329}
330
Rupert Shuttleworth5d60d022020-10-25 05:20:03 +0000331function bazel()
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000332{
Jingwen Chen17d56992021-06-10 08:17:54 +0000333 if which bazel &>/dev/null; then
334 >&2 echo "NOTE: bazel() function sourced from Android's envsetup.sh is being used instead of $(which bazel)"
335 >&2 echo
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000336 fi
337
Jingwen Chen17d56992021-06-10 08:17:54 +0000338 local T="$(gettop)"
339 if [ ! "$T" ]; then
340 >&2 echo "Couldn't locate the top of the Android tree. Try setting TOP. This bazel() function cannot be used outside of the AOSP directory."
341 return
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000342 fi
343
Rupert Shuttleworth5d60d022020-10-25 05:20:03 +0000344 "$T/tools/bazel" "$@"
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000345}
346
Matt Alexanderd9c56562020-05-21 10:49:17 +0000347function printconfig()
348{
Christopher Ferris55257d22017-03-23 11:08:58 -0700349 local T=$(gettop)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800350 if [ ! "$T" ]; then
351 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
352 return
353 fi
354 get_build_var report_config
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700355}
356
Matt Alexanderd9c56562020-05-21 10:49:17 +0000357function set_stuff_for_environment()
358{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800359 setpaths
360 set_sequence_number
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700361
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800362 export ANDROID_BUILD_TOP=$(gettop)
Ben Chengaac3f812013-08-13 14:38:15 -0700363 # With this environment variable new GCC can apply colors to warnings/errors
364 export GCC_COLORS='error=01;31:warning=01;35:note=01;36:caret=01;32:locus=01:quote=01'
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700365}
366
Matt Alexanderd9c56562020-05-21 10:49:17 +0000367function set_sequence_number()
368{
Colin Cross88737132017-03-21 17:41:03 -0700369 export BUILD_ENV_SEQUENCE_NUMBER=13
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700370}
371
Makoto Onukida971062018-06-18 10:15:19 -0700372# Takes a command name, and check if it's in ENVSETUP_NO_COMPLETION or not.
373function should_add_completion() {
Jim Tanga881a252018-06-19 16:34:41 +0800374 local cmd="$(basename $1| sed 's/_completion//' |sed 's/\.\(.*\)*sh$//')"
Makoto Onukida971062018-06-18 10:15:19 -0700375 case :"$ENVSETUP_NO_COMPLETION": in
Jim Tanga881a252018-06-19 16:34:41 +0800376 *:"$cmd":*)
377 return 1
378 ;;
Makoto Onukida971062018-06-18 10:15:19 -0700379 esac
380 return 0
381}
382
Matt Alexanderd9c56562020-05-21 10:49:17 +0000383function addcompletions()
384{
Ben Taitelbaum8c2c9cf2020-09-22 16:45:05 -0700385 local f=
Kenny Root52aa81c2011-07-15 11:07:06 -0700386
Jim Tanga881a252018-06-19 16:34:41 +0800387 # Keep us from trying to run in something that's neither bash nor zsh.
388 if [ -z "$BASH_VERSION" -a -z "$ZSH_VERSION" ]; then
Kenny Root52aa81c2011-07-15 11:07:06 -0700389 return
390 fi
391
392 # Keep us from trying to run in bash that's too old.
Jim Tanga881a252018-06-19 16:34:41 +0800393 if [ -n "$BASH_VERSION" -a ${BASH_VERSINFO[0]} -lt 3 ]; then
Kenny Root52aa81c2011-07-15 11:07:06 -0700394 return
395 fi
396
Jim Tanga881a252018-06-19 16:34:41 +0800397 local completion_files=(
398 system/core/adb/adb.bash
399 system/core/fastboot/fastboot.bash
Jim Tangb3fda302018-12-22 10:24:55 +0800400 tools/asuite/asuite.sh
Jim Tanga881a252018-06-19 16:34:41 +0800401 )
Makoto Onukida971062018-06-18 10:15:19 -0700402 # Completion can be disabled selectively to allow users to use non-standard completion.
403 # e.g.
404 # ENVSETUP_NO_COMPLETION=adb # -> disable adb completion
405 # ENVSETUP_NO_COMPLETION=adb:bit # -> disable adb and bit completion
Jim Tanga881a252018-06-19 16:34:41 +0800406 for f in ${completion_files[*]}; do
407 if [ -f "$f" ] && should_add_completion "$f"; then
Kenny Root52aa81c2011-07-15 11:07:06 -0700408 . $f
Elliott Hughesce18dd42018-04-03 13:49:48 -0700409 fi
410 done
Joe Onorato002a6c72016-10-20 16:39:49 -0700411
Matt Alexanderd9c56562020-05-21 10:49:17 +0000412 if should_add_completion bit ; then
Makoto Onukida971062018-06-18 10:15:19 -0700413 complete -C "bit --tab" bit
414 fi
Anton Hanssonece9c482019-02-04 18:15:39 +0000415 if [ -z "$ZSH_VERSION" ]; then
416 # Doesn't work in zsh.
417 complete -o nospace -F _croot croot
418 fi
Jim Tanga881a252018-06-19 16:34:41 +0800419 complete -F _lunch lunch
Steven Moreland62054a42018-12-06 10:11:40 -0800420
Cole Faust24c36db2021-01-23 02:39:37 +0000421 complete -F _complete_android_module_names pathmod
dimitry73b84812018-12-11 18:06:00 +0100422 complete -F _complete_android_module_names gomod
Cole Faust24c36db2021-01-23 02:39:37 +0000423 complete -F _complete_android_module_names outmod
424 complete -F _complete_android_module_names installmod
dimitry73b84812018-12-11 18:06:00 +0100425 complete -F _complete_android_module_names m
Kenny Root52aa81c2011-07-15 11:07:06 -0700426}
427
Matt Alexanderd9c56562020-05-21 10:49:17 +0000428function choosetype()
429{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700430 echo "Build type choices are:"
431 echo " 1. release"
432 echo " 2. debug"
433 echo
434
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800435 local DEFAULT_NUM DEFAULT_VALUE
Jeff Browne33ba4c2011-07-11 22:11:46 -0700436 DEFAULT_NUM=1
437 DEFAULT_VALUE=release
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700438
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800439 export TARGET_BUILD_TYPE=
440 local ANSWER
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700441 while [ -z $TARGET_BUILD_TYPE ]
442 do
443 echo -n "Which would you like? ["$DEFAULT_NUM"] "
Matt Alexanderd9c56562020-05-21 10:49:17 +0000444 if [ -z "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800445 read ANSWER
446 else
447 echo $1
448 ANSWER=$1
449 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700450 case $ANSWER in
451 "")
452 export TARGET_BUILD_TYPE=$DEFAULT_VALUE
453 ;;
454 1)
455 export TARGET_BUILD_TYPE=release
456 ;;
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800457 release)
458 export TARGET_BUILD_TYPE=release
459 ;;
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700460 2)
461 export TARGET_BUILD_TYPE=debug
462 ;;
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800463 debug)
464 export TARGET_BUILD_TYPE=debug
465 ;;
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700466 *)
467 echo
468 echo "I didn't understand your response. Please try again."
469 echo
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700470 ;;
471 esac
Matt Alexanderd9c56562020-05-21 10:49:17 +0000472 if [ -n "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800473 break
474 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700475 done
476
Ying Wang08800fd2016-03-03 20:57:21 -0800477 build_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700478 set_stuff_for_environment
Ying Wang08800fd2016-03-03 20:57:21 -0800479 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700480}
481
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800482#
483# This function isn't really right: It chooses a TARGET_PRODUCT
484# based on the list of boards. Usually, that gets you something
485# that kinda works with a generic product, but really, you should
486# pick a product by name.
487#
Matt Alexanderd9c56562020-05-21 10:49:17 +0000488function chooseproduct()
489{
Christopher Ferris55257d22017-03-23 11:08:58 -0700490 local default_value
Matt Alexanderd9c56562020-05-21 10:49:17 +0000491 if [ "x$TARGET_PRODUCT" != x ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700492 default_value=$TARGET_PRODUCT
493 else
Ying Wang0a76df52015-06-08 11:57:26 -0700494 default_value=aosp_arm
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700495 fi
496
Ying Wang08800fd2016-03-03 20:57:21 -0800497 export TARGET_BUILD_APPS=
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800498 export TARGET_PRODUCT=
499 local ANSWER
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700500 while [ -z "$TARGET_PRODUCT" ]
501 do
Joe Onorato8849aed2009-04-29 15:56:47 -0700502 echo -n "Which product would you like? [$default_value] "
Matt Alexanderd9c56562020-05-21 10:49:17 +0000503 if [ -z "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800504 read ANSWER
505 else
506 echo $1
507 ANSWER=$1
508 fi
509
Matt Alexanderd9c56562020-05-21 10:49:17 +0000510 if [ -z "$ANSWER" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700511 export TARGET_PRODUCT=$default_value
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800512 else
Matt Alexanderd9c56562020-05-21 10:49:17 +0000513 if check_product $ANSWER
514 then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800515 export TARGET_PRODUCT=$ANSWER
516 else
517 echo "** Not a valid product: $ANSWER"
518 fi
519 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +0000520 if [ -n "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800521 break
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700522 fi
523 done
524
Ying Wang08800fd2016-03-03 20:57:21 -0800525 build_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700526 set_stuff_for_environment
Ying Wang08800fd2016-03-03 20:57:21 -0800527 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700528}
529
Matt Alexanderd9c56562020-05-21 10:49:17 +0000530function choosevariant()
531{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800532 echo "Variant choices are:"
533 local index=1
534 local v
535 for v in ${VARIANT_CHOICES[@]}
536 do
537 # The product name is the name of the directory containing
538 # the makefile we found, above.
539 echo " $index. $v"
540 index=$(($index+1))
541 done
542
543 local default_value=eng
544 local ANSWER
545
546 export TARGET_BUILD_VARIANT=
547 while [ -z "$TARGET_BUILD_VARIANT" ]
548 do
549 echo -n "Which would you like? [$default_value] "
Matt Alexanderd9c56562020-05-21 10:49:17 +0000550 if [ -z "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800551 read ANSWER
552 else
553 echo $1
554 ANSWER=$1
555 fi
556
Matt Alexanderd9c56562020-05-21 10:49:17 +0000557 if [ -z "$ANSWER" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800558 export TARGET_BUILD_VARIANT=$default_value
Matt Alexanderd9c56562020-05-21 10:49:17 +0000559 elif (echo -n $ANSWER | grep -q -e "^[0-9][0-9]*$") ; then
560 if [ "$ANSWER" -le "${#VARIANT_CHOICES[@]}" ] ; then
Guillaume Chelfice000fd2019-10-03 12:02:46 +0200561 export TARGET_BUILD_VARIANT=${VARIANT_CHOICES[@]:$(($ANSWER-1)):1}
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800562 fi
563 else
Matt Alexanderd9c56562020-05-21 10:49:17 +0000564 if check_variant $ANSWER
565 then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800566 export TARGET_BUILD_VARIANT=$ANSWER
567 else
568 echo "** Not a valid variant: $ANSWER"
569 fi
570 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +0000571 if [ -n "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800572 break
573 fi
574 done
575}
576
Matt Alexanderd9c56562020-05-21 10:49:17 +0000577function choosecombo()
578{
Jeff Browne33ba4c2011-07-11 22:11:46 -0700579 choosetype $1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700580
581 echo
582 echo
Jeff Browne33ba4c2011-07-11 22:11:46 -0700583 chooseproduct $2
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700584
585 echo
586 echo
Jeff Browne33ba4c2011-07-11 22:11:46 -0700587 choosevariant $3
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800588
589 echo
Ying Wang08800fd2016-03-03 20:57:21 -0800590 build_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700591 set_stuff_for_environment
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800592 printconfig
Ying Wang08800fd2016-03-03 20:57:21 -0800593 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700594}
595
Matt Alexanderd9c56562020-05-21 10:49:17 +0000596function add_lunch_combo()
597{
Dan Willemsen5436c7e2019-02-11 21:31:47 -0800598 if [ -n "$ZSH_VERSION" ]; then
599 echo -n "${funcfiletrace[1]}: "
600 else
601 echo -n "${BASH_SOURCE[1]}:${BASH_LINENO[0]}: "
602 fi
603 echo "add_lunch_combo is obsolete. Use COMMON_LUNCH_CHOICES in your AndroidProducts.mk instead."
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800604}
605
Matt Alexanderd9c56562020-05-21 10:49:17 +0000606function print_lunch_menu()
607{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700608 local uname=$(uname)
Roland Levillain23c46cf2020-03-31 16:11:05 +0100609 local choices
Colin Crossfa50d402021-04-22 13:05:41 -0700610 choices=$(TARGET_BUILD_APPS= TARGET_PRODUCT= TARGET_BUILD_VARIANT= get_build_var COMMON_LUNCH_CHOICES 2>/dev/null)
Roland Levillain23c46cf2020-03-31 16:11:05 +0100611 local ret=$?
612
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700613 echo
614 echo "You're building on" $uname
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700615 echo
Roland Levillain23c46cf2020-03-31 16:11:05 +0100616
Matt Alexanderd9c56562020-05-21 10:49:17 +0000617 if [ $ret -ne 0 ]
618 then
Roland Levillain23c46cf2020-03-31 16:11:05 +0100619 echo "Warning: Cannot display lunch menu."
620 echo
621 echo "Note: You can invoke lunch with an explicit target:"
622 echo
623 echo " usage: lunch [target]" >&2
624 echo
625 return
626 fi
627
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700628 echo "Lunch menu... pick a combo:"
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800629
630 local i=1
631 local choice
Dan Willemsen91763e92019-10-03 15:13:12 -0700632 for choice in $(echo $choices)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800633 do
634 echo " $i. $choice"
635 i=$(($i+1))
636 done
637
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700638 echo
639}
640
Matt Alexanderd9c56562020-05-21 10:49:17 +0000641function lunch()
642{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800643 local answer
644
Steven Moreland92793dc2020-02-25 18:30:18 -0800645 if [[ $# -gt 1 ]]; then
646 echo "usage: lunch [target]" >&2
647 return 1
648 fi
649
650 if [ "$1" ]; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800651 answer=$1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700652 else
653 print_lunch_menu
Jean-Baptiste Queru324c1232013-03-22 15:53:54 -0700654 echo -n "Which would you like? [aosp_arm-eng] "
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800655 read answer
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700656 fi
657
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800658 local selection=
659
Matt Alexanderd9c56562020-05-21 10:49:17 +0000660 if [ -z "$answer" ]
661 then
Jean-Baptiste Queru324c1232013-03-22 15:53:54 -0700662 selection=aosp_arm-eng
Matt Alexanderd9c56562020-05-21 10:49:17 +0000663 elif (echo -n $answer | grep -q -e "^[0-9][0-9]*$")
664 then
Dan Willemsen5436c7e2019-02-11 21:31:47 -0800665 local choices=($(TARGET_BUILD_APPS= get_build_var COMMON_LUNCH_CHOICES))
Matt Alexanderd9c56562020-05-21 10:49:17 +0000666 if [ $answer -le ${#choices[@]} ]
667 then
Jim Tang0e3397b2018-10-03 18:25:50 +0800668 # array in zsh starts from 1 instead of 0.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000669 if [ -n "$ZSH_VERSION" ]
670 then
Jim Tang0e3397b2018-10-03 18:25:50 +0800671 selection=${choices[$(($answer))]}
672 else
673 selection=${choices[$(($answer-1))]}
674 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800675 fi
Colin Cross88737132017-03-21 17:41:03 -0700676 else
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800677 selection=$answer
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700678 fi
679
Joe Onoratoda12daf2010-06-09 18:18:31 -0700680 export TARGET_BUILD_APPS=
681
Colin Cross88737132017-03-21 17:41:03 -0700682 local product variant_and_version variant version
Colin Cross88737132017-03-21 17:41:03 -0700683 product=${selection%%-*} # Trim everything after first dash
684 variant_and_version=${selection#*-} # Trim everything up to first dash
685 if [ "$variant_and_version" != "$selection" ]; then
686 variant=${variant_and_version%%-*}
687 if [ "$variant" != "$variant_and_version" ]; then
688 version=${variant_and_version#*-}
689 fi
Jeff Browne33ba4c2011-07-11 22:11:46 -0700690 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800691
Matt Alexanderd9c56562020-05-21 10:49:17 +0000692 if [ -z "$product" ]
693 then
Ying Wang08800fd2016-03-03 20:57:21 -0800694 echo
Colin Cross88737132017-03-21 17:41:03 -0700695 echo "Invalid lunch combo: $selection"
Jeff Browne33ba4c2011-07-11 22:11:46 -0700696 return 1
697 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800698
Colin Cross88737132017-03-21 17:41:03 -0700699 TARGET_PRODUCT=$product \
700 TARGET_BUILD_VARIANT=$variant \
701 TARGET_PLATFORM_VERSION=$version \
702 build_build_var_cache
Matt Alexanderd9c56562020-05-21 10:49:17 +0000703 if [ $? -ne 0 ]
704 then
Anton Hansson32fa7ee2021-06-14 17:09:58 +0100705 if [[ "$product" =~ .*_(eng|user|userdebug) ]]
706 then
707 echo "Did you mean -${product/*_/}? (dash instead of underscore)"
708 fi
Colin Cross88737132017-03-21 17:41:03 -0700709 return 1
710 fi
Colin Cross88737132017-03-21 17:41:03 -0700711 export TARGET_PRODUCT=$(get_build_var TARGET_PRODUCT)
712 export TARGET_BUILD_VARIANT=$(get_build_var TARGET_BUILD_VARIANT)
Colin Crossb105e362017-05-01 14:21:28 -0700713 if [ -n "$version" ]; then
714 export TARGET_PLATFORM_VERSION=$(get_build_var TARGET_PLATFORM_VERSION)
715 else
716 unset TARGET_PLATFORM_VERSION
717 fi
Jeff Browne33ba4c2011-07-11 22:11:46 -0700718 export TARGET_BUILD_TYPE=release
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700719
Sasha Smundak90d07bc2020-06-04 10:48:15 -0700720 [[ -n "${ANDROID_QUIET_BUILD:-}" ]] || echo
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800721
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700722 set_stuff_for_environment
Sasha Smundak90d07bc2020-06-04 10:48:15 -0700723 [[ -n "${ANDROID_QUIET_BUILD:-}" ]] || printconfig
Ying Wang08800fd2016-03-03 20:57:21 -0800724 destroy_build_var_cache
Kousik Kumar41dacd12021-05-11 18:38:38 -0400725
726 if [[ -n "${CHECK_MU_CONFIG:-}" ]]; then
727 check_mu_config
728 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700729}
730
Dan Willemsenaf2e1f82018-04-04 15:41:41 -0700731unset COMMON_LUNCH_CHOICES_CACHE
Jeff Davidson513d7a42010-08-02 10:00:44 -0700732# Tab completion for lunch.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000733function _lunch()
734{
Jeff Davidson513d7a42010-08-02 10:00:44 -0700735 local cur prev opts
736 COMPREPLY=()
737 cur="${COMP_WORDS[COMP_CWORD]}"
738 prev="${COMP_WORDS[COMP_CWORD-1]}"
739
Dan Willemsenaf2e1f82018-04-04 15:41:41 -0700740 if [ -z "$COMMON_LUNCH_CHOICES_CACHE" ]; then
Dan Willemsen5436c7e2019-02-11 21:31:47 -0800741 COMMON_LUNCH_CHOICES_CACHE=$(TARGET_BUILD_APPS= get_build_var COMMON_LUNCH_CHOICES)
Dan Willemsenaf2e1f82018-04-04 15:41:41 -0700742 fi
743
744 COMPREPLY=( $(compgen -W "${COMMON_LUNCH_CHOICES_CACHE}" -- ${cur}) )
Jeff Davidson513d7a42010-08-02 10:00:44 -0700745 return 0
746}
Jeff Davidson513d7a42010-08-02 10:00:44 -0700747
Joe Onoratoda12daf2010-06-09 18:18:31 -0700748# Configures the build to build unbundled apps.
Doug Zongker0d8179e2014-04-16 11:34:34 -0700749# Run tapas with one or more app names (from LOCAL_PACKAGE_NAME)
Matt Alexanderd9c56562020-05-21 10:49:17 +0000750function tapas()
751{
Jeff Gaston9fb05d82017-08-21 18:27:00 -0700752 local showHelp="$(echo $* | xargs -n 1 echo | \grep -E '^(help)$' | xargs)"
Elliott Hughesf71c05a2020-03-06 16:46:59 -0800753 local arch="$(echo $* | xargs -n 1 echo | \grep -E '^(arm|x86|arm64|x86_64)$' | xargs)"
Doug Zongker0d8179e2014-04-16 11:34:34 -0700754 local variant="$(echo $* | xargs -n 1 echo | \grep -E '^(user|userdebug|eng)$' | xargs)"
Jeff Hamilton5069bd62014-09-04 21:28:00 -0700755 local density="$(echo $* | xargs -n 1 echo | \grep -E '^(ldpi|mdpi|tvdpi|hdpi|xhdpi|xxhdpi|xxxhdpi|alldpi)$' | xargs)"
Elliott Hughesf71c05a2020-03-06 16:46:59 -0800756 local apps="$(echo $* | xargs -n 1 echo | \grep -E -v '^(user|userdebug|eng|arm|x86|arm64|x86_64|ldpi|mdpi|tvdpi|hdpi|xhdpi|xxhdpi|xxxhdpi|alldpi)$' | xargs)"
Joe Onoratoda12daf2010-06-09 18:18:31 -0700757
Jeff Gaston9fb05d82017-08-21 18:27:00 -0700758 if [ "$showHelp" != "" ]; then
759 $(gettop)/build/make/tapasHelp.sh
760 return
761 fi
762
Ying Wang67f02922012-08-22 10:25:20 -0700763 if [ $(echo $arch | wc -w) -gt 1 ]; then
764 echo "tapas: Error: Multiple build archs supplied: $arch"
765 return
766 fi
Joe Onoratoda12daf2010-06-09 18:18:31 -0700767 if [ $(echo $variant | wc -w) -gt 1 ]; then
768 echo "tapas: Error: Multiple build variants supplied: $variant"
769 return
770 fi
Jeff Hamilton5069bd62014-09-04 21:28:00 -0700771 if [ $(echo $density | wc -w) -gt 1 ]; then
772 echo "tapas: Error: Multiple densities supplied: $density"
773 return
774 fi
Ying Wang67f02922012-08-22 10:25:20 -0700775
Ying Wang0a76df52015-06-08 11:57:26 -0700776 local product=aosp_arm
Ying Wang67f02922012-08-22 10:25:20 -0700777 case $arch in
Matt Alexanderd9c56562020-05-21 10:49:17 +0000778 x86) product=aosp_x86;;
779 arm64) product=aosp_arm64;;
780 x86_64) product=aosp_x86_64;;
Ying Wang67f02922012-08-22 10:25:20 -0700781 esac
Joe Onoratoda12daf2010-06-09 18:18:31 -0700782 if [ -z "$variant" ]; then
783 variant=eng
784 fi
Ying Wangc048c9b2010-06-24 15:08:33 -0700785 if [ -z "$apps" ]; then
786 apps=all
787 fi
Justin Morey29d225c2014-11-04 13:35:51 -0600788 if [ -z "$density" ]; then
789 density=alldpi
790 fi
Joe Onoratoda12daf2010-06-09 18:18:31 -0700791
Ying Wang67f02922012-08-22 10:25:20 -0700792 export TARGET_PRODUCT=$product
Joe Onoratoda12daf2010-06-09 18:18:31 -0700793 export TARGET_BUILD_VARIANT=$variant
Jeff Hamilton5069bd62014-09-04 21:28:00 -0700794 export TARGET_BUILD_DENSITY=$density
Joe Onoratoda12daf2010-06-09 18:18:31 -0700795 export TARGET_BUILD_TYPE=release
796 export TARGET_BUILD_APPS=$apps
797
Ying Wang08800fd2016-03-03 20:57:21 -0800798 build_build_var_cache
Joe Onoratoda12daf2010-06-09 18:18:31 -0700799 set_stuff_for_environment
800 printconfig
Ying Wang08800fd2016-03-03 20:57:21 -0800801 destroy_build_var_cache
Joe Onoratoda12daf2010-06-09 18:18:31 -0700802}
803
Martin Stjernholmf692c752021-04-12 00:01:10 +0100804# Configures the build to build unbundled Android modules (APEXes).
805# Run banchan with one or more module names (from apex{} modules).
806function banchan()
807{
808 local showHelp="$(echo $* | xargs -n 1 echo | \grep -E '^(help)$' | xargs)"
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100809 local product="$(echo $* | xargs -n 1 echo | \grep -E '^(.*_)?(arm|x86|arm64|x86_64)$' | xargs)"
Martin Stjernholmf692c752021-04-12 00:01:10 +0100810 local variant="$(echo $* | xargs -n 1 echo | \grep -E '^(user|userdebug|eng)$' | xargs)"
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100811 local apps="$(echo $* | xargs -n 1 echo | \grep -E -v '^(user|userdebug|eng|(.*_)?(arm|x86|arm64|x86_64))$' | xargs)"
Martin Stjernholmf692c752021-04-12 00:01:10 +0100812
813 if [ "$showHelp" != "" ]; then
814 $(gettop)/build/make/banchanHelp.sh
815 return
816 fi
817
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100818 if [ -z "$product" ]; then
819 product=arm
820 elif [ $(echo $product | wc -w) -gt 1 ]; then
821 echo "banchan: Error: Multiple build archs or products supplied: $products"
Martin Stjernholmf692c752021-04-12 00:01:10 +0100822 return
823 fi
824 if [ $(echo $variant | wc -w) -gt 1 ]; then
825 echo "banchan: Error: Multiple build variants supplied: $variant"
826 return
827 fi
828 if [ -z "$apps" ]; then
829 echo "banchan: Error: No modules supplied"
830 return
831 fi
832
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100833 case $product in
834 arm) product=module_arm;;
Martin Stjernholmf692c752021-04-12 00:01:10 +0100835 x86) product=module_x86;;
836 arm64) product=module_arm64;;
837 x86_64) product=module_x86_64;;
838 esac
839 if [ -z "$variant" ]; then
840 variant=eng
841 fi
842
843 export TARGET_PRODUCT=$product
844 export TARGET_BUILD_VARIANT=$variant
845 export TARGET_BUILD_DENSITY=alldpi
846 export TARGET_BUILD_TYPE=release
847
848 # This setup currently uses TARGET_BUILD_APPS just like tapas, but the use
849 # case is different and it may diverge in the future.
850 export TARGET_BUILD_APPS=$apps
851
852 build_build_var_cache
853 set_stuff_for_environment
854 printconfig
855 destroy_build_var_cache
856}
857
Matt Alexanderd9c56562020-05-21 10:49:17 +0000858function gettop
859{
Colin Cross6cdc5d22017-10-20 11:37:33 -0700860 local TOPFILE=build/make/core/envsetup.mk
Matt Alexanderd9c56562020-05-21 10:49:17 +0000861 if [ -n "$TOP" -a -f "$TOP/$TOPFILE" ] ; then
Brian Carlstroma5c4f172014-09-12 00:33:25 -0700862 # The following circumlocution ensures we remove symlinks from TOP.
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000863 (cd "$TOP"; PWD= /bin/pwd)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700864 else
Matt Alexanderd9c56562020-05-21 10:49:17 +0000865 if [ -f $TOPFILE ] ; then
Dan Bornsteind0b274d2009-11-24 15:48:50 -0800866 # The following circumlocution (repeated below as well) ensures
867 # that we record the true directory name and not one that is
868 # faked up with symlink names.
869 PWD= /bin/pwd
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700870 else
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800871 local HERE=$PWD
Christopher Ferris55257d22017-03-23 11:08:58 -0700872 local T=
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000873 while [ \( ! \( -f $TOPFILE \) \) -a \( "$PWD" != "/" \) ]; do
Ying Wang9cd17642012-12-13 10:52:07 -0800874 \cd ..
synergyb112a402013-07-05 19:47:47 -0700875 T=`PWD= /bin/pwd -P`
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700876 done
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000877 \cd "$HERE"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700878 if [ -f "$T/$TOPFILE" ]; then
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000879 echo "$T"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700880 fi
881 fi
882 fi
883}
884
Matt Alexanderd9c56562020-05-21 10:49:17 +0000885function croot()
886{
Christopher Ferris55257d22017-03-23 11:08:58 -0700887 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700888 if [ "$T" ]; then
Marie Janssen32ec50a2016-04-21 16:53:39 -0700889 if [ "$1" ]; then
890 \cd $(gettop)/$1
891 else
892 \cd $(gettop)
893 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700894 else
895 echo "Couldn't locate the top of the tree. Try setting TOP."
896 fi
897}
898
Matt Alexanderd9c56562020-05-21 10:49:17 +0000899function _croot()
900{
Anton Hanssonece9c482019-02-04 18:15:39 +0000901 local T=$(gettop)
902 if [ "$T" ]; then
903 local cur="${COMP_WORDS[COMP_CWORD]}"
904 k=0
905 for c in $(compgen -d ${T}/${cur}); do
906 COMPREPLY[k++]=${c#${T}/}/
907 done
908 fi
909}
910
Matt Alexanderd9c56562020-05-21 10:49:17 +0000911function cproj()
912{
Colin Cross6cdc5d22017-10-20 11:37:33 -0700913 local TOPFILE=build/make/core/envsetup.mk
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700914 local HERE=$PWD
Christopher Ferris55257d22017-03-23 11:08:58 -0700915 local T=
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700916 while [ \( ! \( -f $TOPFILE \) \) -a \( $PWD != "/" \) ]; do
917 T=$PWD
918 if [ -f "$T/Android.mk" ]; then
Ying Wang9cd17642012-12-13 10:52:07 -0800919 \cd $T
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700920 return
921 fi
Ying Wang9cd17642012-12-13 10:52:07 -0800922 \cd ..
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700923 done
Ying Wang9cd17642012-12-13 10:52:07 -0800924 \cd $HERE
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700925 echo "can't find Android.mk"
926}
927
Daniel Sandler47e0a882013-07-30 13:23:52 -0400928# simplified version of ps; output in the form
929# <pid> <procname>
930function qpid() {
931 local prepend=''
932 local append=''
Matt Alexanderd9c56562020-05-21 10:49:17 +0000933 if [ "$1" = "--exact" ]; then
Daniel Sandler47e0a882013-07-30 13:23:52 -0400934 prepend=' '
935 append='$'
936 shift
Matt Alexanderd9c56562020-05-21 10:49:17 +0000937 elif [ "$1" = "--help" -o "$1" = "-h" ]; then
Ying Wang08800fd2016-03-03 20:57:21 -0800938 echo "usage: qpid [[--exact] <process name|pid>"
939 return 255
940 fi
Daniel Sandler47e0a882013-07-30 13:23:52 -0400941
942 local EXE="$1"
Matt Alexanderd9c56562020-05-21 10:49:17 +0000943 if [ "$EXE" ] ; then
Ying Wang08800fd2016-03-03 20:57:21 -0800944 qpid | \grep "$prepend$EXE$append"
945 else
946 adb shell ps \
947 | tr -d '\r' \
948 | sed -e 1d -e 's/^[^ ]* *\([0-9]*\).* \([^ ]*\)$/\1 \2/'
949 fi
Daniel Sandler47e0a882013-07-30 13:23:52 -0400950}
951
Steven Moreland74114f12020-09-10 01:23:32 +0000952# syswrite - disable verity, reboot if needed, and remount image
953#
954# Easy way to make system.img/etc writable
955function syswrite() {
956 adb wait-for-device && adb root || return 1
957 if [[ $(adb disable-verity | grep "reboot") ]]; then
958 echo "rebooting"
959 adb reboot && adb wait-for-device && adb root || return 1
960 fi
961 adb wait-for-device && adb remount || return 1
962}
963
Iliyan Malcheve675cfb2014-11-03 17:04:47 -0800964# coredump_setup - enable core dumps globally for any process
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700965# that has the core-file-size limit set correctly
966#
Iliyan Malchevaf5de972014-11-04 20:57:37 -0800967# NOTE: You must call also coredump_enable for a specific process
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700968# if its core-file-size limit is not set already.
969# NOTE: Core dumps are written to ramdisk; they will not survive a reboot!
970
Matt Alexanderd9c56562020-05-21 10:49:17 +0000971function coredump_setup()
972{
973 echo "Getting root...";
974 adb root;
975 adb wait-for-device;
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700976
Matt Alexanderd9c56562020-05-21 10:49:17 +0000977 echo "Remounting root partition read-write...";
978 adb shell mount -w -o remount -t rootfs rootfs;
979 sleep 1;
980 adb wait-for-device;
981 adb shell mkdir -p /cores;
982 adb shell mount -t tmpfs tmpfs /cores;
983 adb shell chmod 0777 /cores;
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700984
Matt Alexanderd9c56562020-05-21 10:49:17 +0000985 echo "Granting SELinux permission to dump in /cores...";
986 adb shell restorecon -R /cores;
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700987
Matt Alexanderd9c56562020-05-21 10:49:17 +0000988 echo "Set core pattern.";
989 adb shell 'echo /cores/core.%p > /proc/sys/kernel/core_pattern';
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700990
Ying Wang08800fd2016-03-03 20:57:21 -0800991 echo "Done."
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700992}
993
Iliyan Malchevaf5de972014-11-04 20:57:37 -0800994# coredump_enable - enable core dumps for the specified process
Matt Alexanderd9c56562020-05-21 10:49:17 +0000995# $1 = PID of process (e.g., $(pid mediaserver))
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700996#
Iliyan Malchevaf5de972014-11-04 20:57:37 -0800997# NOTE: coredump_setup must have been called as well for a core
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700998# dump to actually be generated.
999
Matt Alexanderd9c56562020-05-21 10:49:17 +00001000function coredump_enable()
1001{
1002 local PID=$1;
Ying Wang08800fd2016-03-03 20:57:21 -08001003 if [ -z "$PID" ]; then
Matt Alexanderd9c56562020-05-21 10:49:17 +00001004 printf "Expecting a PID!\n";
1005 return;
1006 fi;
1007 echo "Setting core limit for $PID to infinite...";
Elliott Hughes910a3552016-03-07 13:53:53 -08001008 adb shell /system/bin/ulimit -p $PID -c unlimited
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001009}
1010
1011# core - send SIGV and pull the core for process
Matt Alexanderd9c56562020-05-21 10:49:17 +00001012# $1 = PID of process (e.g., $(pid mediaserver))
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001013#
Iliyan Malchevaf5de972014-11-04 20:57:37 -08001014# NOTE: coredump_setup must be called once per boot for core dumps to be
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001015# enabled globally.
1016
Matt Alexanderd9c56562020-05-21 10:49:17 +00001017function core()
1018{
1019 local PID=$1;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001020
Ying Wang08800fd2016-03-03 20:57:21 -08001021 if [ -z "$PID" ]; then
Matt Alexanderd9c56562020-05-21 10:49:17 +00001022 printf "Expecting a PID!\n";
1023 return;
1024 fi;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001025
Matt Alexanderd9c56562020-05-21 10:49:17 +00001026 local CORENAME=core.$PID;
1027 local COREPATH=/cores/$CORENAME;
1028 local SIG=SEGV;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001029
Matt Alexanderd9c56562020-05-21 10:49:17 +00001030 coredump_enable $1;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001031
Matt Alexanderd9c56562020-05-21 10:49:17 +00001032 local done=0;
Ying Wang08800fd2016-03-03 20:57:21 -08001033 while [ $(adb shell "[ -d /proc/$PID ] && echo -n yes") ]; do
Matt Alexanderd9c56562020-05-21 10:49:17 +00001034 printf "\tSending SIG%s to %d...\n" $SIG $PID;
1035 adb shell kill -$SIG $PID;
1036 sleep 1;
1037 done;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001038
Matt Alexanderd9c56562020-05-21 10:49:17 +00001039 adb shell "while [ ! -f $COREPATH ] ; do echo waiting for $COREPATH to be generated; sleep 1; done"
1040 echo "Done: core is under $COREPATH on device.";
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001041}
1042
Christopher Tate744ee802009-11-12 15:33:08 -08001043# systemstack - dump the current stack trace of all threads in the system process
1044# to the usual ANR traces file
Matt Alexanderd9c56562020-05-21 10:49:17 +00001045function systemstack()
1046{
Jeff Sharkeyf5824372013-02-19 17:00:46 -08001047 stacks system_server
1048}
1049
Michael Wrightaeed7212014-06-19 19:58:12 -07001050# Read the ELF header from /proc/$PID/exe to determine if the process is
1051# 64-bit.
Matt Alexanderd9c56562020-05-21 10:49:17 +00001052function is64bit()
1053{
Ben Chengfba67bf2014-02-25 10:27:07 -08001054 local PID="$1"
Matt Alexanderd9c56562020-05-21 10:49:17 +00001055 if [ "$PID" ] ; then
1056 if [[ "$(adb shell cat /proc/$PID/exe | xxd -l 1 -s 4 -p)" -eq "02" ]] ; then
Ben Chengfba67bf2014-02-25 10:27:07 -08001057 echo "64"
1058 else
1059 echo ""
1060 fi
1061 else
1062 echo ""
1063 fi
1064}
1065
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001066case `uname -s` in
1067 Darwin)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001068 function sgrep()
1069 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001070 find -E . -name .repo -prune -o -name .git -prune -o -type f -iregex '.*\.(c|h|cc|cpp|hpp|S|java|kt|xml|sh|mk|aidl|vts|proto)' \
Mike Frysinger5e479732015-09-22 18:13:48 -04001071 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001072 }
Matt Alexanderd9c56562020-05-21 10:49:17 +00001073
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001074 ;;
1075 *)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001076 function sgrep()
1077 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001078 find . -name .repo -prune -o -name .git -prune -o -type f -iregex '.*\.\(c\|h\|cc\|cpp\|hpp\|S\|java\|kt\|xml\|sh\|mk\|aidl\|vts\|proto\)' \
Mike Frysinger5e479732015-09-22 18:13:48 -04001079 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001080 }
1081 ;;
1082esac
1083
Matt Alexanderd9c56562020-05-21 10:49:17 +00001084function gettargetarch
1085{
Raghu Gandham8da43102012-07-25 19:57:22 -07001086 get_build_var TARGET_ARCH
1087}
1088
Matt Alexanderd9c56562020-05-21 10:49:17 +00001089function ggrep()
1090{
Mike Frysinger5e479732015-09-22 18:13:48 -04001091 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.gradle" \
1092 -exec grep --color -n "$@" {} +
Jon Boekenoogencbca56f2014-04-07 10:57:38 -07001093}
1094
Matt Alexanderd9c56562020-05-21 10:49:17 +00001095function gogrep()
1096{
Orion Hodson831472d2019-10-25 11:35:15 +01001097 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.go" \
1098 -exec grep --color -n "$@" {} +
1099}
1100
Matt Alexanderd9c56562020-05-21 10:49:17 +00001101function jgrep()
1102{
Mike Frysinger5e479732015-09-22 18:13:48 -04001103 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.java" \
1104 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001105}
1106
Alistair Delva176e5342021-02-22 13:31:26 -08001107function rsgrep()
Jeff Vander Stoep1431ab82021-02-02 19:18:26 +01001108{
1109 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.rs" \
1110 -exec grep --color -n "$@" {} +
1111}
1112
Taesu Leeea0cecd2020-10-28 11:05:18 +09001113function ktgrep()
1114{
1115 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.kt" \
1116 -exec grep --color -n "$@" {} +
1117}
1118
Matt Alexanderd9c56562020-05-21 10:49:17 +00001119function cgrep()
1120{
Mike Frysinger5e479732015-09-22 18:13:48 -04001121 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f \( -name '*.c' -o -name '*.cc' -o -name '*.cpp' -o -name '*.h' -o -name '*.hpp' \) \
1122 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001123}
1124
Matt Alexanderd9c56562020-05-21 10:49:17 +00001125function resgrep()
1126{
Christopher Ferris55257d22017-03-23 11:08:58 -07001127 local dir
Mike Frysinger5e479732015-09-22 18:13:48 -04001128 for dir in `find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -name res -type d`; do
1129 find $dir -type f -name '*\.xml' -exec grep --color -n "$@" {} +
1130 done
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001131}
1132
Matt Alexanderd9c56562020-05-21 10:49:17 +00001133function mangrep()
1134{
Mike Frysinger5e479732015-09-22 18:13:48 -04001135 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o -type f -name 'AndroidManifest.xml' \
1136 -exec grep --color -n "$@" {} +
Jeff Sharkey50b61e92013-03-08 10:20:47 -08001137}
1138
Matt Alexanderd9c56562020-05-21 10:49:17 +00001139function owngrep()
1140{
Jeff Sharkeyf17cddf2019-08-21 12:51:26 -06001141 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o -type f -name 'OWNERS' \
1142 -exec grep --color -n "$@" {} +
1143}
1144
Matt Alexanderd9c56562020-05-21 10:49:17 +00001145function sepgrep()
1146{
Mike Frysinger5e479732015-09-22 18:13:48 -04001147 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o -name sepolicy -type d \
1148 -exec grep --color -n -r --exclude-dir=\.git "$@" {} +
Alex Klyubinba5fc8e2013-05-06 14:11:48 -07001149}
1150
Matt Alexanderd9c56562020-05-21 10:49:17 +00001151function rcgrep()
1152{
Mike Frysinger5e479732015-09-22 18:13:48 -04001153 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.rc*" \
1154 -exec grep --color -n "$@" {} +
Jeff Sharkeyea0068a2015-02-26 14:13:46 -08001155}
1156
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001157case `uname -s` in
1158 Darwin)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001159 function mgrep()
1160 {
Orion Hodson831472d2019-10-25 11:35:15 +01001161 find -E . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o \( -iregex '.*/(Makefile|Makefile\..*|.*\.make|.*\.mak|.*\.mk|.*\.bp)' -o -regex '(.*/)?(build|soong)/.*[^/]*\.go' \) -type f \
Mike Frysinger5e479732015-09-22 18:13:48 -04001162 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001163 }
1164
Matt Alexanderd9c56562020-05-21 10:49:17 +00001165 function treegrep()
1166 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001167 find -E . -name .repo -prune -o -name .git -prune -o -type f -iregex '.*\.(c|h|cpp|hpp|S|java|kt|xml)' \
Mike Frysinger5e479732015-09-22 18:13:48 -04001168 -exec grep --color -n -i "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001169 }
1170
1171 ;;
1172 *)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001173 function mgrep()
1174 {
Orion Hodson831472d2019-10-25 11:35:15 +01001175 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o \( -regextype posix-egrep -iregex '(.*\/Makefile|.*\/Makefile\..*|.*\.make|.*\.mak|.*\.mk|.*\.bp)' -o -regextype posix-extended -regex '(.*/)?(build|soong)/.*[^/]*\.go' \) -type f \
Mike Frysinger5e479732015-09-22 18:13:48 -04001176 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001177 }
1178
Matt Alexanderd9c56562020-05-21 10:49:17 +00001179 function treegrep()
1180 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001181 find . -name .repo -prune -o -name .git -prune -o -regextype posix-egrep -iregex '.*\.(c|h|cpp|hpp|S|java|kt|xml)' -type f \
Mike Frysinger5e479732015-09-22 18:13:48 -04001182 -exec grep --color -n -i "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001183 }
1184
1185 ;;
1186esac
1187
Matt Alexanderd9c56562020-05-21 10:49:17 +00001188function getprebuilt
1189{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001190 get_abs_build_var ANDROID_PREBUILTS
1191}
1192
Matt Alexanderd9c56562020-05-21 10:49:17 +00001193function tracedmdump()
1194{
Christopher Ferris55257d22017-03-23 11:08:58 -07001195 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001196 if [ ! "$T" ]; then
1197 echo "Couldn't locate the top of the tree. Try setting TOP."
1198 return
1199 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001200 local prebuiltdir=$(getprebuilt)
Raghu Gandham8da43102012-07-25 19:57:22 -07001201 local arch=$(gettargetarch)
1202 local KERNEL=$T/prebuilts/qemu-kernel/$arch/vmlinux-qemu
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001203
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001204 local TRACE=$1
Matt Alexanderd9c56562020-05-21 10:49:17 +00001205 if [ ! "$TRACE" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001206 echo "usage: tracedmdump tracename"
1207 return
1208 fi
1209
Matt Alexanderd9c56562020-05-21 10:49:17 +00001210 if [ ! -r "$KERNEL" ] ; then
Jack Veenstra60116fc2009-04-09 18:12:34 -07001211 echo "Error: cannot find kernel: '$KERNEL'"
1212 return
1213 fi
1214
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001215 local BASETRACE=$(basename $TRACE)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001216 if [ "$BASETRACE" = "$TRACE" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001217 TRACE=$ANDROID_PRODUCT_OUT/traces/$TRACE
1218 fi
1219
1220 echo "post-processing traces..."
1221 rm -f $TRACE/qtrace.dexlist
1222 post_trace $TRACE
1223 if [ $? -ne 0 ]; then
1224 echo "***"
1225 echo "*** Error: malformed trace. Did you remember to exit the emulator?"
1226 echo "***"
1227 return
1228 fi
1229 echo "generating dexlist output..."
1230 /bin/ls $ANDROID_PRODUCT_OUT/system/framework/*.jar $ANDROID_PRODUCT_OUT/system/app/*.apk $ANDROID_PRODUCT_OUT/data/app/*.apk 2>/dev/null | xargs dexlist > $TRACE/qtrace.dexlist
1231 echo "generating dmtrace data..."
1232 q2dm -r $ANDROID_PRODUCT_OUT/symbols $TRACE $KERNEL $TRACE/dmtrace || return
1233 echo "generating html file..."
1234 dmtracedump -h $TRACE/dmtrace >| $TRACE/dmtrace.html || return
1235 echo "done, see $TRACE/dmtrace.html for details"
1236 echo "or run:"
1237 echo " traceview $TRACE/dmtrace"
1238}
1239
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001240# communicate with a running device or emulator, set up necessary state,
1241# and run the hat command.
Matt Alexanderd9c56562020-05-21 10:49:17 +00001242function runhat()
1243{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001244 # process standard adb options
1245 local adbTarget=""
Matt Alexanderd9c56562020-05-21 10:49:17 +00001246 if [ "$1" = "-d" -o "$1" = "-e" ]; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001247 adbTarget=$1
1248 shift 1
Matt Alexanderd9c56562020-05-21 10:49:17 +00001249 elif [ "$1" = "-s" ]; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001250 adbTarget="$1 $2"
1251 shift 2
1252 fi
1253 local adbOptions=${adbTarget}
Matt Alexanderd9c56562020-05-21 10:49:17 +00001254 #echo adbOptions = ${adbOptions}
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001255
1256 # runhat options
1257 local targetPid=$1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001258
Matt Alexanderd9c56562020-05-21 10:49:17 +00001259 if [ "$targetPid" = "" ]; then
Andy McFaddenb6289852010-07-12 08:00:19 -07001260 echo "Usage: runhat [ -d | -e | -s serial ] target-pid"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001261 return
1262 fi
1263
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001264 # confirm hat is available
1265 if [ -z $(which hat) ]; then
1266 echo "hat is not available in this configuration."
1267 return
1268 fi
1269
Andy McFaddenb6289852010-07-12 08:00:19 -07001270 # issue "am" command to cause the hprof dump
Nick Kralevich9948b1e2014-07-18 15:45:38 -07001271 local devFile=/data/local/tmp/hprof-$targetPid
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001272 echo "Poking $targetPid and waiting for data..."
Dianne Hackborn6b9549f2012-09-26 15:00:59 -07001273 echo "Storing data at $devFile"
Andy McFaddenb6289852010-07-12 08:00:19 -07001274 adb ${adbOptions} shell am dumpheap $targetPid $devFile
The Android Open Source Project88b60792009-03-03 19:28:42 -08001275 echo "Press enter when logcat shows \"hprof: heap dump completed\""
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001276 echo -n "> "
1277 read
1278
The Android Open Source Project88b60792009-03-03 19:28:42 -08001279 local localFile=/tmp/$$-hprof
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001280
The Android Open Source Project88b60792009-03-03 19:28:42 -08001281 echo "Retrieving file $devFile..."
1282 adb ${adbOptions} pull $devFile $localFile
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001283
The Android Open Source Project88b60792009-03-03 19:28:42 -08001284 adb ${adbOptions} shell rm $devFile
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001285
The Android Open Source Project88b60792009-03-03 19:28:42 -08001286 echo "Running hat on $localFile"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001287 echo "View the output by pointing your browser at http://localhost:7000/"
1288 echo ""
Dianne Hackborn6e4e1bb2011-11-10 15:19:51 -08001289 hat -JXmx512m $localFile
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001290}
1291
Matt Alexanderd9c56562020-05-21 10:49:17 +00001292function getbugreports()
1293{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001294 local reports=(`adb shell ls /sdcard/bugreports | tr -d '\r'`)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001295
1296 if [ ! "$reports" ]; then
1297 echo "Could not locate any bugreports."
1298 return
1299 fi
1300
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001301 local report
1302 for report in ${reports[@]}
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001303 do
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001304 echo "/sdcard/bugreports/${report}"
1305 adb pull /sdcard/bugreports/${report} ${report}
1306 gunzip ${report}
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001307 done
1308}
1309
Matt Alexanderd9c56562020-05-21 10:49:17 +00001310function getsdcardpath()
1311{
Victoria Lease1b296b42012-08-21 15:44:06 -07001312 adb ${adbOptions} shell echo -n \$\{EXTERNAL_STORAGE\}
1313}
1314
Matt Alexanderd9c56562020-05-21 10:49:17 +00001315function getscreenshotpath()
1316{
Victoria Lease1b296b42012-08-21 15:44:06 -07001317 echo "$(getsdcardpath)/Pictures/Screenshots"
1318}
1319
Matt Alexanderd9c56562020-05-21 10:49:17 +00001320function getlastscreenshot()
1321{
Victoria Lease1b296b42012-08-21 15:44:06 -07001322 local screenshot_path=$(getscreenshotpath)
1323 local screenshot=`adb ${adbOptions} ls ${screenshot_path} | grep Screenshot_[0-9-]*.*\.png | sort -rk 3 | cut -d " " -f 4 | head -n 1`
Matt Alexanderd9c56562020-05-21 10:49:17 +00001324 if [ "$screenshot" = "" ]; then
Victoria Lease1b296b42012-08-21 15:44:06 -07001325 echo "No screenshots found."
1326 return
1327 fi
1328 echo "${screenshot}"
1329 adb ${adbOptions} pull ${screenshot_path}/${screenshot}
1330}
1331
Matt Alexanderd9c56562020-05-21 10:49:17 +00001332function startviewserver()
1333{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001334 local port=4939
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001335 if [ $# -gt 0 ]; then
1336 port=$1
1337 fi
1338 adb shell service call window 1 i32 $port
1339}
1340
Matt Alexanderd9c56562020-05-21 10:49:17 +00001341function stopviewserver()
1342{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001343 adb shell service call window 2
1344}
1345
Matt Alexanderd9c56562020-05-21 10:49:17 +00001346function isviewserverstarted()
1347{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001348 adb shell service call window 3
1349}
1350
Matt Alexanderd9c56562020-05-21 10:49:17 +00001351function key_home()
1352{
Romain Guyb84049a2010-10-04 16:56:11 -07001353 adb shell input keyevent 3
1354}
1355
Matt Alexanderd9c56562020-05-21 10:49:17 +00001356function key_back()
1357{
Romain Guyb84049a2010-10-04 16:56:11 -07001358 adb shell input keyevent 4
1359}
1360
Matt Alexanderd9c56562020-05-21 10:49:17 +00001361function key_menu()
1362{
Romain Guyb84049a2010-10-04 16:56:11 -07001363 adb shell input keyevent 82
1364}
1365
Matt Alexanderd9c56562020-05-21 10:49:17 +00001366function smoketest()
1367{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001368 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
1369 echo "Couldn't locate output files. Try running 'lunch' first." >&2
1370 return
1371 fi
Christopher Ferris55257d22017-03-23 11:08:58 -07001372 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001373 if [ ! "$T" ]; then
1374 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
1375 return
1376 fi
1377
Ying Wang9cd17642012-12-13 10:52:07 -08001378 (\cd "$T" && mmm tests/SmokeTest) &&
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001379 adb uninstall com.android.smoketest > /dev/null &&
1380 adb uninstall com.android.smoketest.tests > /dev/null &&
1381 adb install $ANDROID_PRODUCT_OUT/data/app/SmokeTestApp.apk &&
1382 adb install $ANDROID_PRODUCT_OUT/data/app/SmokeTest.apk &&
1383 adb shell am instrument -w com.android.smoketest.tests/android.test.InstrumentationTestRunner
1384}
1385
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001386# simple shortcut to the runtest command
Matt Alexanderd9c56562020-05-21 10:49:17 +00001387function runtest()
1388{
Christopher Ferris55257d22017-03-23 11:08:58 -07001389 local T=$(gettop)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001390 if [ ! "$T" ]; then
1391 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
1392 return
1393 fi
Brett Chabot3fb149d2009-10-21 20:05:26 -07001394 ("$T"/development/testrunner/runtest.py $@)
Brett Chabot762748c2009-03-27 10:25:11 -07001395}
1396
The Android Open Source Project88b60792009-03-03 19:28:42 -08001397function godir () {
1398 if [[ -z "$1" ]]; then
1399 echo "Usage: godir <regex>"
1400 return
1401 fi
Christopher Ferris55257d22017-03-23 11:08:58 -07001402 local T=$(gettop)
1403 local FILELIST
Matt Alexanderd9c56562020-05-21 10:49:17 +00001404 if [ ! "$OUT_DIR" = "" ]; then
Brian Carlstromf2257422015-09-30 20:28:54 -07001405 mkdir -p $OUT_DIR
1406 FILELIST=$OUT_DIR/filelist
1407 else
1408 FILELIST=$T/filelist
1409 fi
1410 if [[ ! -f $FILELIST ]]; then
The Android Open Source Project88b60792009-03-03 19:28:42 -08001411 echo -n "Creating index..."
Brian Carlstromf2257422015-09-30 20:28:54 -07001412 (\cd $T; find . -wholename ./out -prune -o -wholename ./.repo -prune -o -type f > $FILELIST)
The Android Open Source Project88b60792009-03-03 19:28:42 -08001413 echo " Done"
1414 echo ""
1415 fi
1416 local lines
Brian Carlstromf2257422015-09-30 20:28:54 -07001417 lines=($(\grep "$1" $FILELIST | sed -e 's/\/[^/]*$//' | sort | uniq))
Matt Alexanderd9c56562020-05-21 10:49:17 +00001418 if [[ ${#lines[@]} = 0 ]]; then
The Android Open Source Project88b60792009-03-03 19:28:42 -08001419 echo "Not found"
1420 return
1421 fi
1422 local pathname
1423 local choice
1424 if [[ ${#lines[@]} > 1 ]]; then
1425 while [[ -z "$pathname" ]]; do
1426 local index=1
1427 local line
1428 for line in ${lines[@]}; do
1429 printf "%6s %s\n" "[$index]" $line
Doug Zongker29034982011-04-22 08:16:56 -07001430 index=$(($index + 1))
The Android Open Source Project88b60792009-03-03 19:28:42 -08001431 done
1432 echo
1433 echo -n "Select one: "
1434 unset choice
1435 read choice
1436 if [[ $choice -gt ${#lines[@]} || $choice -lt 1 ]]; then
1437 echo "Invalid choice"
1438 continue
1439 fi
Guillaume Chelfice000fd2019-10-03 12:02:46 +02001440 pathname=${lines[@]:$(($choice-1)):1}
The Android Open Source Project88b60792009-03-03 19:28:42 -08001441 done
1442 else
Guillaume Chelfice000fd2019-10-03 12:02:46 +02001443 pathname=${lines[@]:0:1}
The Android Open Source Project88b60792009-03-03 19:28:42 -08001444 fi
Ying Wang9cd17642012-12-13 10:52:07 -08001445 \cd $T/$pathname
The Android Open Source Project88b60792009-03-03 19:28:42 -08001446}
1447
Steven Moreland62054a42018-12-06 10:11:40 -08001448# Update module-info.json in out.
1449function refreshmod() {
1450 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
1451 echo "No ANDROID_PRODUCT_OUT. Try running 'lunch' first." >&2
1452 return 1
1453 fi
1454
1455 echo "Refreshing modules (building module-info.json). Log at $ANDROID_PRODUCT_OUT/module-info.json.build.log." >&2
1456
1457 # for the output of the next command
1458 mkdir -p $ANDROID_PRODUCT_OUT || return 1
1459
1460 # Note, can't use absolute path because of the way make works.
Alessandro Astonec8771be2020-05-10 11:27:57 +02001461 m $(get_build_var PRODUCT_OUT)/module-info.json \
Steven Moreland62054a42018-12-06 10:11:40 -08001462 > $ANDROID_PRODUCT_OUT/module-info.json.build.log 2>&1
1463}
1464
Cole Faust3e192382021-10-25 13:29:15 -07001465# Verifies that module-info.txt exists, returning nonzero if it doesn't.
Cole Faust24c36db2021-01-23 02:39:37 +00001466function verifymodinfo() {
Steven Moreland62054a42018-12-06 10:11:40 -08001467 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
Joe Onorato0bac4fe2021-04-07 08:51:28 -07001468 if [ "$QUIET_VERIFYMODINFO" != "true" ] ; then
1469 echo "No ANDROID_PRODUCT_OUT. Try running 'lunch' first." >&2
1470 fi
Steven Moreland62054a42018-12-06 10:11:40 -08001471 return 1
1472 fi
1473
1474 if [ ! -f "$ANDROID_PRODUCT_OUT/module-info.json" ]; then
Joe Onorato0bac4fe2021-04-07 08:51:28 -07001475 if [ "$QUIET_VERIFYMODINFO" != "true" ] ; then
Cole Faust3e192382021-10-25 13:29:15 -07001476 echo "Could not find module-info.json. Please run 'refreshmod' first." >&2
Joe Onorato0bac4fe2021-04-07 08:51:28 -07001477 fi
1478 return 1
Steven Moreland62054a42018-12-06 10:11:40 -08001479 fi
Cole Faust24c36db2021-01-23 02:39:37 +00001480}
1481
1482# List all modules for the current device, as cached in module-info.json. If any build change is
1483# made and it should be reflected in the output, you should run 'refreshmod' first.
1484function allmod() {
1485 verifymodinfo || return 1
Steven Moreland62054a42018-12-06 10:11:40 -08001486
Joe Onorato4acbe3b2021-04-29 15:31:42 -07001487 python3 -c "import json; print('\n'.join(sorted(json.load(open('$ANDROID_PRODUCT_OUT/module-info.json')).keys())))"
Steven Moreland62054a42018-12-06 10:11:40 -08001488}
1489
Joe Onorato2c1aa472021-02-25 16:42:39 -08001490# Get the path of a specific module in the android tree, as cached in module-info.json.
1491# If any build change is made, and it should be reflected in the output, you should run
1492# 'refreshmod' first. Note: This is the inverse of dirmods.
Rett Berg78d1c932019-01-24 14:34:23 -08001493function pathmod() {
Steven Moreland62054a42018-12-06 10:11:40 -08001494 if [[ $# -ne 1 ]]; then
Rett Berg78d1c932019-01-24 14:34:23 -08001495 echo "usage: pathmod <module>" >&2
Steven Moreland62054a42018-12-06 10:11:40 -08001496 return 1
1497 fi
1498
Cole Faust24c36db2021-01-23 02:39:37 +00001499 verifymodinfo || return 1
Steven Moreland62054a42018-12-06 10:11:40 -08001500
Joe Onorato4acbe3b2021-04-29 15:31:42 -07001501 local relpath=$(python3 -c "import json, os
Steven Moreland62054a42018-12-06 10:11:40 -08001502module = '$1'
1503module_info = json.load(open('$ANDROID_PRODUCT_OUT/module-info.json'))
1504if module not in module_info:
1505 exit(1)
LuK1337b6a78192020-01-12 03:12:17 +01001506print(module_info[module]['path'][0])" 2>/dev/null)
Steven Moreland62054a42018-12-06 10:11:40 -08001507
1508 if [ -z "$relpath" ]; then
1509 echo "Could not find module '$1' (try 'refreshmod' if there have been build changes?)." >&2
1510 return 1
1511 else
Rett Berg78d1c932019-01-24 14:34:23 -08001512 echo "$ANDROID_BUILD_TOP/$relpath"
Steven Moreland62054a42018-12-06 10:11:40 -08001513 fi
1514}
1515
Joe Onorato2c1aa472021-02-25 16:42:39 -08001516# Get the path of a specific module in the android tree, as cached in module-info.json.
1517# If any build change is made, and it should be reflected in the output, you should run
1518# 'refreshmod' first. Note: This is the inverse of pathmod.
1519function dirmods() {
1520 if [[ $# -ne 1 ]]; then
1521 echo "usage: dirmods <path>" >&2
1522 return 1
1523 fi
1524
1525 verifymodinfo || return 1
1526
Joe Onorato4acbe3b2021-04-29 15:31:42 -07001527 python3 -c "import json, os
Joe Onorato2c1aa472021-02-25 16:42:39 -08001528dir = '$1'
1529while dir.endswith('/'):
1530 dir = dir[:-1]
1531prefix = dir + '/'
1532module_info = json.load(open('$ANDROID_PRODUCT_OUT/module-info.json'))
1533results = set()
1534for m in module_info.values():
1535 for path in m.get(u'path', []):
1536 if path == dir or path.startswith(prefix):
1537 name = m.get(u'module_name')
1538 if name:
1539 results.add(name)
1540for name in sorted(results):
1541 print(name)
1542"
1543}
1544
1545
Rett Berg78d1c932019-01-24 14:34:23 -08001546# Go to a specific module in the android tree, as cached in module-info.json. If any build change
1547# is made, and it should be reflected in the output, you should run 'refreshmod' first.
1548function gomod() {
1549 if [[ $# -ne 1 ]]; then
1550 echo "usage: gomod <module>" >&2
1551 return 1
1552 fi
1553
1554 local path="$(pathmod $@)"
1555 if [ -z "$path" ]; then
1556 return 1
1557 fi
1558 cd $path
1559}
1560
Cole Faust24c36db2021-01-23 02:39:37 +00001561# Gets the list of a module's installed outputs, as cached in module-info.json.
1562# If any build change is made, and it should be reflected in the output, you should run 'refreshmod' first.
1563function outmod() {
1564 if [[ $# -ne 1 ]]; then
1565 echo "usage: outmod <module>" >&2
1566 return 1
1567 fi
1568
1569 verifymodinfo || return 1
1570
1571 local relpath
Joe Onorato4acbe3b2021-04-29 15:31:42 -07001572 relpath=$(python3 -c "import json, os
Cole Faust24c36db2021-01-23 02:39:37 +00001573module = '$1'
1574module_info = json.load(open('$ANDROID_PRODUCT_OUT/module-info.json'))
1575if module not in module_info:
1576 exit(1)
1577for output in module_info[module]['installed']:
1578 print(os.path.join('$ANDROID_BUILD_TOP', output))" 2>/dev/null)
1579
1580 if [ $? -ne 0 ]; then
1581 echo "Could not find module '$1' (try 'refreshmod' if there have been build changes?)" >&2
1582 return 1
1583 elif [ ! -z "$relpath" ]; then
1584 echo "$relpath"
1585 fi
1586}
1587
1588# adb install a module's apk, as cached in module-info.json. If any build change
1589# is made, and it should be reflected in the output, you should run 'refreshmod' first.
1590# Usage: installmod [adb install arguments] <module>
1591# For example: installmod -r Dialer -> adb install -r /path/to/Dialer.apk
1592function installmod() {
1593 if [[ $# -eq 0 ]]; then
1594 echo "usage: installmod [adb install arguments] <module>" >&2
Cole Faust3e192382021-10-25 13:29:15 -07001595 echo "" >&2
1596 echo "Only flags to be passed after the \"install\" in adb install are supported," >&2
1597 echo "with the exception of -s. If -s is passed it will be placed before the \"install\"." >&2
1598 echo "-s must be the first flag passed if it exists." >&2
Cole Faust24c36db2021-01-23 02:39:37 +00001599 return 1
1600 fi
1601
1602 local _path
1603 _path=$(outmod ${@:$#:1})
1604 if [ $? -ne 0 ]; then
1605 return 1
1606 fi
1607
1608 _path=$(echo "$_path" | grep -E \\.apk$ | head -n 1)
1609 if [ -z "$_path" ]; then
1610 echo "Module '$1' does not produce a file ending with .apk (try 'refreshmod' if there have been build changes?)" >&2
1611 return 1
1612 fi
Cole Faust3e192382021-10-25 13:29:15 -07001613 local serial_device=""
1614 if [[ "$1" == "-s" ]]; then
1615 if [[ $# -le 2 ]]; then
1616 echo "-s requires an argument" >&2
1617 return 1
1618 fi
1619 serial_device="-s $2"
1620 shift 2
1621 fi
Cole Faust24c36db2021-01-23 02:39:37 +00001622 local length=$(( $# - 1 ))
Cole Faust3e192382021-10-25 13:29:15 -07001623 echo adb $serial_device install ${@:1:$length} $_path
1624 adb $serial_device install ${@:1:$length} $_path
Cole Faust24c36db2021-01-23 02:39:37 +00001625}
1626
dimitry73b84812018-12-11 18:06:00 +01001627function _complete_android_module_names() {
Steven Moreland62054a42018-12-06 10:11:40 -08001628 local word=${COMP_WORDS[COMP_CWORD]}
Joe Onorato0bac4fe2021-04-07 08:51:28 -07001629 COMPREPLY=( $(QUIET_VERIFYMODINFO=true allmod | grep -E "^$word") )
Steven Moreland62054a42018-12-06 10:11:40 -08001630}
1631
Alex Rayf0d08eb2013-03-08 15:15:06 -08001632# Print colored exit condition
1633function pez {
Michael Wrighteb733842013-03-08 17:34:02 -08001634 "$@"
1635 local retval=$?
Matt Alexanderd9c56562020-05-21 10:49:17 +00001636 if [ $retval -ne 0 ]
1637 then
Jacky Cao89483b82015-05-15 22:12:53 +08001638 echo $'\E'"[0;31mFAILURE\e[00m"
Michael Wrighteb733842013-03-08 17:34:02 -08001639 else
Jacky Cao89483b82015-05-15 22:12:53 +08001640 echo $'\E'"[0;32mSUCCESS\e[00m"
Michael Wrighteb733842013-03-08 17:34:02 -08001641 fi
1642 return $retval
Alex Rayf0d08eb2013-03-08 15:15:06 -08001643}
1644
Matt Alexanderd9c56562020-05-21 10:49:17 +00001645function get_make_command()
1646{
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001647 # If we're in the top of an Android tree, use soong_ui.bash instead of make
1648 if [ -f build/soong/soong_ui.bash ]; then
Dan Willemsene9842242017-07-28 13:00:13 -07001649 # Always use the real make if -C is passed in
1650 for arg in "$@"; do
1651 if [[ $arg == -C* ]]; then
1652 echo command make
1653 return
1654 fi
1655 done
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001656 echo build/soong/soong_ui.bash --make-mode
1657 else
1658 echo command make
1659 fi
Ying Wanged21d4c2014-08-24 22:14:19 -07001660}
1661
Matt Alexanderd9c56562020-05-21 10:49:17 +00001662function _wrap_build()
1663{
Sasha Smundak9f27cc02019-01-31 13:25:31 -08001664 if [[ "${ANDROID_QUIET_BUILD:-}" == true ]]; then
1665 "$@"
1666 return $?
1667 fi
Ed Heylcc6be0a2014-06-18 14:55:58 -07001668 local start_time=$(date +"%s")
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001669 "$@"
Ed Heylcc6be0a2014-06-18 14:55:58 -07001670 local ret=$?
1671 local end_time=$(date +"%s")
1672 local tdiff=$(($end_time-$start_time))
1673 local hours=$(($tdiff / 3600 ))
1674 local mins=$((($tdiff % 3600) / 60))
1675 local secs=$(($tdiff % 60))
Greg Hackmannd95c7f72014-06-23 14:05:06 -07001676 local ncolors=$(tput colors 2>/dev/null)
1677 if [ -n "$ncolors" ] && [ $ncolors -ge 8 ]; then
Jacky Cao89483b82015-05-15 22:12:53 +08001678 color_failed=$'\E'"[0;31m"
1679 color_success=$'\E'"[0;32m"
Kousik Kumar09af2542021-08-19 16:13:32 -04001680 color_warning=$'\E'"[0;33m"
Jacky Cao89483b82015-05-15 22:12:53 +08001681 color_reset=$'\E'"[00m"
Greg Hackmannd95c7f72014-06-23 14:05:06 -07001682 else
1683 color_failed=""
1684 color_success=""
1685 color_reset=""
1686 fi
Kousik Kumar09af2542021-08-19 16:13:32 -04001687
1688 if [[ "x${USE_RBE}" == "x" && $mins -gt 15 && "${ANDROID_BUILD_ENVIRONMENT_CONFIG}" == "googler" ]]; then
1689 echo
1690 echo "${color_warning}Start using RBE (http://go/build-fast) to get faster builds!${color_reset}"
1691 fi
1692
Ed Heylcc6be0a2014-06-18 14:55:58 -07001693 echo
Matt Alexanderd9c56562020-05-21 10:49:17 +00001694 if [ $ret -eq 0 ] ; then
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001695 echo -n "${color_success}#### build completed successfully "
Ed Heylcc6be0a2014-06-18 14:55:58 -07001696 else
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001697 echo -n "${color_failed}#### failed to build some targets "
Ed Heylcc6be0a2014-06-18 14:55:58 -07001698 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +00001699 if [ $hours -gt 0 ] ; then
Ed Heylcc6be0a2014-06-18 14:55:58 -07001700 printf "(%02g:%02g:%02g (hh:mm:ss))" $hours $mins $secs
Matt Alexanderd9c56562020-05-21 10:49:17 +00001701 elif [ $mins -gt 0 ] ; then
Ed Heylcc6be0a2014-06-18 14:55:58 -07001702 printf "(%02g:%02g (mm:ss))" $mins $secs
Matt Alexanderd9c56562020-05-21 10:49:17 +00001703 elif [ $secs -gt 0 ] ; then
Ed Heylcc6be0a2014-06-18 14:55:58 -07001704 printf "(%s seconds)" $secs
1705 fi
Jacky Cao89483b82015-05-15 22:12:53 +08001706 echo " ####${color_reset}"
Ed Heylcc6be0a2014-06-18 14:55:58 -07001707 echo
1708 return $ret
1709}
1710
Patrice Arrudafa7204b2019-06-20 23:40:33 +00001711function _trigger_build()
1712(
1713 local -r bc="$1"; shift
1714 if T="$(gettop)"; then
1715 _wrap_build "$T/build/soong/soong_ui.bash" --build-mode --${bc} --dir="$(pwd)" "$@"
1716 else
Jingwen Chend728ee12021-05-18 06:02:53 +00001717 >&2 echo "Couldn't locate the top of the tree. Try setting TOP."
1718 return 1
Patrice Arrudafa7204b2019-06-20 23:40:33 +00001719 fi
1720)
1721
Jingwen Chen69f9ed12021-06-16 09:44:26 +00001722# Convenience entry point (like m) to use Bazel in AOSP.
Jingwen Chend728ee12021-05-18 06:02:53 +00001723function b()
1724(
1725 # Generate BUILD, bzl files into the synthetic Bazel workspace (out/soong/workspace).
Lukacs T. Berki3fef6602021-09-07 08:18:35 +02001726 _trigger_build "all-modules" bp2build USE_BAZEL_ANALYSIS= || return 1
Jingwen Chend728ee12021-05-18 06:02:53 +00001727 # Then, run Bazel using the synthetic workspace as the --package_path.
Jingwen Chen69f9ed12021-06-16 09:44:26 +00001728 if [[ -z "$@" ]]; then
1729 # If there are no args, show help.
Jingwen Chenbfa114d2021-06-17 05:42:43 +00001730 bazel help
Jingwen Chen69f9ed12021-06-16 09:44:26 +00001731 else
1732 # Else, always run with the bp2build configuration, which sets Bazel's package path to the synthetic workspace.
Jingwen Chenbfa114d2021-06-17 05:42:43 +00001733 bazel "$@" --config=bp2build
Jingwen Chen69f9ed12021-06-16 09:44:26 +00001734 fi
Jingwen Chend728ee12021-05-18 06:02:53 +00001735)
1736
Patrice Arrudafa7204b2019-06-20 23:40:33 +00001737function m()
1738(
1739 _trigger_build "all-modules" "$@"
1740)
1741
1742function mm()
1743(
1744 _trigger_build "modules-in-a-dir-no-deps" "$@"
1745)
1746
1747function mmm()
1748(
1749 _trigger_build "modules-in-dirs-no-deps" "$@"
1750)
1751
1752function mma()
1753(
1754 _trigger_build "modules-in-a-dir" "$@"
1755)
1756
1757function mmma()
1758(
1759 _trigger_build "modules-in-dirs" "$@"
1760)
1761
Matt Alexanderd9c56562020-05-21 10:49:17 +00001762function make()
1763{
Dan Willemsene9842242017-07-28 13:00:13 -07001764 _wrap_build $(get_make_command "$@") "$@"
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001765}
1766
Matt Alexanderd9c56562020-05-21 10:49:17 +00001767function provision()
1768{
David Zeuthen1b126ff2015-09-30 17:10:48 -04001769 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
1770 echo "Couldn't locate output files. Try running 'lunch' first." >&2
1771 return 1
1772 fi
1773 if [ ! -e "$ANDROID_PRODUCT_OUT/provision-device" ]; then
1774 echo "There is no provisioning script for the device." >&2
1775 return 1
1776 fi
1777
1778 # Check if user really wants to do this.
Matt Alexanderd9c56562020-05-21 10:49:17 +00001779 if [ "$1" = "--no-confirmation" ]; then
David Zeuthen1b126ff2015-09-30 17:10:48 -04001780 shift 1
1781 else
1782 echo "This action will reflash your device."
1783 echo ""
1784 echo "ALL DATA ON THE DEVICE WILL BE IRREVOCABLY ERASED."
1785 echo ""
Marie Janssen4afc2c02015-11-10 10:41:15 -08001786 echo -n "Are you sure you want to do this (yes/no)? "
1787 read
Matt Alexanderd9c56562020-05-21 10:49:17 +00001788 if [[ "${REPLY}" != "yes" ]] ; then
David Zeuthen1b126ff2015-09-30 17:10:48 -04001789 echo "Not taking any action. Exiting." >&2
1790 return 1
1791 fi
1792 fi
1793 "$ANDROID_PRODUCT_OUT/provision-device" "$@"
1794}
1795
Jim Tanga881a252018-06-19 16:34:41 +08001796# Zsh needs bashcompinit called to support bash-style completion.
Patrik Fimmldf248e62018-10-15 18:15:12 +02001797function enable_zsh_completion() {
1798 # Don't override user's options if bash-style completion is already enabled.
1799 if ! declare -f complete >/dev/null; then
1800 autoload -U compinit && compinit
1801 autoload -U bashcompinit && bashcompinit
1802 fi
Jim Tanga881a252018-06-19 16:34:41 +08001803}
1804
1805function validate_current_shell() {
1806 local current_sh="$(ps -o command -p $$)"
1807 case "$current_sh" in
Raphael Moll70a86b02011-06-20 16:03:14 -07001808 *bash*)
Jim Tanga881a252018-06-19 16:34:41 +08001809 function check_type() { type -t "$1"; }
Raphael Moll70a86b02011-06-20 16:03:14 -07001810 ;;
Jim Tanga881a252018-06-19 16:34:41 +08001811 *zsh*)
1812 function check_type() { type "$1"; }
Matt Alexanderd9c56562020-05-21 10:49:17 +00001813 enable_zsh_completion ;;
Raphael Moll70a86b02011-06-20 16:03:14 -07001814 *)
Jim Tanga881a252018-06-19 16:34:41 +08001815 echo -e "WARNING: Only bash and zsh are supported.\nUse of other shell would lead to erroneous results."
Raphael Moll70a86b02011-06-20 16:03:14 -07001816 ;;
1817 esac
Jim Tanga881a252018-06-19 16:34:41 +08001818}
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001819
1820# Execute the contents of any vendorsetup.sh files we can find.
Dan Willemsend855a722019-02-12 15:52:36 -08001821# Unless we find an allowed-vendorsetup_sh-files file, in which case we'll only
1822# load those.
1823#
1824# This allows loading only approved vendorsetup.sh files
Jim Tanga881a252018-06-19 16:34:41 +08001825function source_vendorsetup() {
Jim Tangc4dba1d2019-07-25 16:54:27 +08001826 unset VENDOR_PYTHONPATH
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001827 local T="$(gettop)"
Dan Willemsend855a722019-02-12 15:52:36 -08001828 allowed=
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001829 for f in $(cd "$T" && find -L device vendor product -maxdepth 4 -name 'allowed-vendorsetup_sh-files' 2>/dev/null | sort); do
Dan Willemsend855a722019-02-12 15:52:36 -08001830 if [ -n "$allowed" ]; then
1831 echo "More than one 'allowed_vendorsetup_sh-files' file found, not including any vendorsetup.sh files:"
1832 echo " $allowed"
1833 echo " $f"
1834 return
1835 fi
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001836 allowed="$T/$f"
Dan Willemsend855a722019-02-12 15:52:36 -08001837 done
1838
1839 allowed_files=
1840 [ -n "$allowed" ] && allowed_files=$(cat "$allowed")
Jim Tanga881a252018-06-19 16:34:41 +08001841 for dir in device vendor product; do
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001842 for f in $(cd "$T" && test -d $dir && \
Jim Tanga881a252018-06-19 16:34:41 +08001843 find -L $dir -maxdepth 4 -name 'vendorsetup.sh' 2>/dev/null | sort); do
Dan Willemsend855a722019-02-12 15:52:36 -08001844
1845 if [[ -z "$allowed" || "$allowed_files" =~ $f ]]; then
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001846 echo "including $f"; . "$T/$f"
Dan Willemsend855a722019-02-12 15:52:36 -08001847 else
1848 echo "ignoring $f, not in $allowed"
1849 fi
Jim Tanga881a252018-06-19 16:34:41 +08001850 done
1851 done
1852}
Kenny Root52aa81c2011-07-15 11:07:06 -07001853
Dan Albertbab814f2020-08-26 15:34:53 -07001854function showcommands() {
1855 local T=$(gettop)
1856 if [[ -z "$TARGET_PRODUCT" ]]; then
1857 >&2 echo "TARGET_PRODUCT not set. Run lunch."
1858 return
1859 fi
1860 case $(uname -s) in
1861 Darwin)
1862 PREBUILT_NAME=darwin-x86
1863 ;;
1864 Linux)
1865 PREBUILT_NAME=linux-x86
1866 ;;
1867 *)
1868 >&2 echo Unknown host $(uname -s)
1869 return
1870 ;;
1871 esac
1872 if [[ -z "$OUT_DIR" ]]; then
1873 if [[ -z "$OUT_DIR_COMMON_BASE" ]]; then
1874 OUT_DIR=out
1875 else
1876 OUT_DIR=${OUT_DIR_COMMON_BASE}/${PWD##*/}
1877 fi
1878 fi
1879 if [[ "$1" == "--regenerate" ]]; then
1880 shift 1
1881 NINJA_ARGS="-t commands $@" m
1882 else
1883 (cd $T && prebuilts/build-tools/$PREBUILT_NAME/bin/ninja \
1884 -f $OUT_DIR/combined-${TARGET_PRODUCT}.ninja \
1885 -t commands "$@")
1886 fi
1887}
1888
Jim Tanga881a252018-06-19 16:34:41 +08001889validate_current_shell
1890source_vendorsetup
Kenny Root52aa81c2011-07-15 11:07:06 -07001891addcompletions